//----------------------------------------------------------------------
//------------------------------- CURSOR.C -----------------------------
//----------------------------------------------------------------------
//-------------------- Cursorfunktion-Unterprogramm --------------------
//------------------- Erstellt von: Georg Delle ------------------------



#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include "wdit_typ.h"

#define text_x1 -5700 //Zahlenausgabe Abszisse
#define text_x2 -6000 //Abszisse:
#define text_x3  4500 //Ordinate:
#define text_x4  4800 //Zahlenausgabe Ordinate
#define text_y1  8500 //Abszisse
#define text_y2  8500 //Ordinate Satz 1
#define text_y3  7300 //Ordinate Satz 2
#define text_y4  6100 //Differenz



LOGFONT			lfont;
extern short   Modell;
extern BOOL	   ueber_p;
unsigned			xposalt;
unsigned			xposShannalt;


int Cursorfunktion(HWND hwnd, LONG lParam, int x, int y)
 {
 HPEN						hPen;
 POINT         		point;
 HDC           		hdc;
 TEXTMETRIC				tm;
 unsigned				xpos;
 void						ETP_Fenstereigenschaften (HWND hwnd, HDC hdc);
 void						Loeschen(HDC hdc, int y);
 void						ETP_Ausgabe(HDC, TEXTMETRIC, int, int, unsigned);

 hdc = GetDC(hwnd);
 hPen = SelectObject(hdc, (CreatePen (PS_SOLID, 0, RGB(200,200,200))));
 ETP_Fenstereigenschaften(hwnd, hdc);
 point.x = LOWORD(lParam);
 point.y = HIWORD(lParam);
 DPtoLP (hdc, (LPPOINT) &point, 1);
 GetTextMetrics(hdc,&tm);

 x*=tm.tmAveCharWidth;
 y*=tm.tmHeight;
 if(point.x>=x && point.x<x+9250)
  {
  xpos=(unsigned)point.x*4/184;
  ETP_Ausgabe(hdc, tm, x, y, xpos);
  SetROP2(hdc, R2_XORPEN);
  MoveTo(hdc, point.x, y);
  LineTo(hdc, point.x, y+10000);
  MoveTo(hdc, xposalt, y);
  LineTo(hdc, xposalt, y+10000);
  xposalt=(unsigned)point.x;
  }
 DeleteObject(SelectObject(hdc, hPen));
 ReleaseDC (hwnd, hdc);
 return;
 }


void ETP_Ausgabe(HDC hdc, TEXTMETRIC tm, int x, int y, unsigned xpos)
 {
 char						szBuffer[40];
 extern float			pH[201];
 extern float			H1[201];
 extern float			H2[201];
 extern float			H3[201];
 extern float			HM[201];
 extern float			HM_K[3][201];


 xpos-=(unsigned)x*4/184;
 if(ueber_p)
  sprintf(szBuffer, " p= %.3f ", pH[xpos]);
 else
  sprintf(szBuffer, " k= %.3f ", pH[xpos]);
 TextOut(hdc, x+4000, y+11000, szBuffer, strlen(szBuffer));
 if(Modell==3 || Modell==6)
  {
  sprintf(szBuffer, " H1= %.4f ", H1[xpos]);
  SetTextColor(hdc, RGB(0, 0, 150));
  TextOut(hdc, x+9500, y+11000, szBuffer, strlen(szBuffer));
  sprintf(szBuffer, " H2= %.4f ", H2[xpos]);
  SetTextColor(hdc, RGB(150, 0, 0));
  TextOut(hdc, x+9500, y+11000-tm.tmHeight, szBuffer, strlen(szBuffer));
  sprintf(szBuffer, " H3= %.4f ", H3[xpos]);
  SetTextColor(hdc, RGB(150, 150, 0));
  TextOut(hdc, x+9500, y+11000-2*tm.tmHeight, szBuffer, strlen(szBuffer));
  SetTextColor(hdc, RGB(0, 150, 0));
  sprintf(szBuffer, " HM= %.4f ", HM[xpos]);
  TextOut(hdc, x+9500, y+11000-3*tm.tmHeight, szBuffer, strlen(szBuffer));
  }
 else if(Modell==4 || Modell==7)
  {
  sprintf(szBuffer, " H= %.4f ", HM[xpos]);
  SetTextColor(hdc, RGB(0, 0, 150));
  TextOut(hdc, x+9500, y+11000, szBuffer, strlen(szBuffer));
  sprintf(szBuffer, " H= %.4f ", HM_K[0][xpos]);
  SetTextColor(hdc, RGB(150, 0, 0));
  TextOut(hdc, x+9500, y+11000-tm.tmHeight, szBuffer, strlen(szBuffer));
  sprintf(szBuffer, " H= %.4f ", HM_K[1][xpos]);
  SetTextColor(hdc, RGB(150, 150, 0));
  TextOut(hdc, x+9500, y+11000-2*tm.tmHeight, szBuffer, strlen(szBuffer));
  SetTextColor(hdc, RGB(0, 150, 0));
  sprintf(szBuffer, " H= %.4f ", HM_K[2][xpos]);
  TextOut(hdc, x+9500, y+11000-3*tm.tmHeight, szBuffer, strlen(szBuffer));
  }

 return;
 }


void CursorShannon(HWND hwnd, LONG lParam, int x, int y)
 {
 HPEN						hPen;
 POINT         		point;
 HDC           		hdc;
 TEXTMETRIC				tm;
 unsigned				xposShann;
 void						Shannon_Fenstereigenschaften (HWND hwnd, HDC hdc);
 void						Loeschen(HDC hdc, int y);
 void						Shannon_Ausgabe(HDC, int, int, unsigned);

 hdc = GetDC(hwnd);
 hPen = SelectObject(hdc, (CreatePen (PS_SOLID, 0, RGB(200,200,200))));
 Shannon_Fenstereigenschaften(hwnd, hdc);
 point.x = LOWORD(lParam);
 point.y = HIWORD(lParam);
 DPtoLP (hdc, (LPPOINT) &point, 1);
 GetTextMetrics(hdc,&tm);

 x*=tm.tmAveCharWidth;
 y*=tm.tmHeight;
 if(point.x>=x && point.x<x+9250)
  {
  xposShann=(unsigned)point.x*4/184;
  Shannon_Ausgabe(hdc, x, y, xposShann);
  SetROP2(hdc, R2_XORPEN);
  MoveTo(hdc, point.x, y);
  LineTo(hdc, point.x, y+10000);
  MoveTo(hdc, xposShannalt, y);
  LineTo(hdc, xposShannalt, y+10000);
  xposShannalt=(unsigned)point.x;
  }
 DeleteObject(SelectObject(hdc, hPen));
 ReleaseDC (hwnd, hdc);

 return;
 }


void Shannon_Ausgabe(HDC hdc, int x, int y, unsigned xposShann)
 {
 char						szBuffer[40];
 extern float			pShann[201];
 extern float			Shann[201];

 xposShann-=(unsigned)x*4/184;
 sprintf(szBuffer, " p= %.3f ", pShann[xposShann]);
 TextOut(hdc, x+1000, y+11000, szBuffer, strlen(szBuffer));
 sprintf(szBuffer, " S(p)= %.4f ", Shann[xposShann]);
 SetTextColor(hdc, RGB(0, 0, 150));
 TextOut(hdc, x+6000, y+11000, szBuffer, strlen(szBuffer));

 return;
 }


void Fenstereigenschaften (HWND hwnd, HDC hdc)
 {
 RECT rect;

 SetMapMode (hdc, MM_ISOTROPIC);
 GetClientRect (hwnd, &rect);
 SetWindowExt (hdc, 10000, 10000);  // logische Groesse
 SetViewportExt (hdc, .5*rect.right, -.5*rect.bottom);
					 // physikalische Groesse
 SetViewportOrg (hdc, .5*rect.right, .5*rect.bottom);
					 // Mittelpunkt
 return;
 }


void ETP_Fenstereigenschaften (HWND hwnd, HDC hdc)
 {
 RECT rect;

 SetMapMode (hdc, MM_ISOTROPIC);
 GetClientRect (hwnd, &rect);
 if(Modell==1 || Modell==5)
  {
  SetWindowExt(hdc,1000,1000);
  }
 else
  {
  SetWindowExt(hdc,18000,10000);
  }
 if(Modell==2)
  {
  SetViewportExt(hdc, 0.9*rect.right, 0.9*rect.bottom);
  SetViewportOrg(hdc, 0.05*rect.right, 0.25*rect.bottom);
  }
 else
  {
  SetViewportExt(hdc, 0.9*rect.right,-0.9*rect.bottom);
  SetViewportOrg(hdc, 0.2*rect.right, 0.9*rect.bottom);
  }

 return;
 }


void Shannon_Fenstereigenschaften (HWND hwnd, HDC hdc)
 {
 RECT rect;

 SetMapMode (hdc, MM_ISOTROPIC);
 GetClientRect (hwnd, &rect);
 SetWindowExt(hdc,12000,12000);
 SetViewportExt(hdc, 0.9*rect.right,-0.9*rect.bottom);
 SetViewportOrg(hdc, 0.2*rect.right, 0.9*rect.bottom);

 return;
 }



