//-------------------------------------------------------------------------
//------------------------------- ETP_WND.C -------------------------------
//-------------------------------------------------------------------------
//--- Fensterfunktion Entropieausgabe "Wertdiskrete Informationstheorie ---
//-------------------- Erstellt von: Georg Delle --------------------------


#include <windows.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "wdit.h"
#include "wdit_typ.h"

#define xlinks -7500
#define yunten -8000
#define yoben 5500
#define ywertneg_cursor 0
#define ywertpos_cursor 1
#define ynorm_lin 12500
#define xnorm_log 8000
#define IDC_SH 1
HFONT						  hFont;
HPEN				        hPen;
LOGFONT					  lf;
extern HMENU           hMenu, hMenuWindow;
extern HANDLE          hInst;
extern HCURSOR         hCurWait, hCurArrow;
extern HWND				  hwndFrame;
extern LPSTR           lpstrPar;
extern LPSTR			  lpstrPar2;
extern STRUCT_FENSTER  Fenster;
extern STRUCT_TOCHTER  HFK, ETP;
extern STRUCT_DATEI    Datei1, Datei2;
extern STRUCT_PUNKT    ptETP1[100], ptETP2[100];
extern short			  Modell;
extern BOOL				  codiert;
extern BOOL				  decodiert;
extern BOOL				  pApBfest;
extern BOOL				  ueber_p;
extern float			  pMarkov2[2];
extern float			  pMarkov3;
extern float			  KonstMarkov;
extern float			  K[3];
extern int				  xpos;
extern int				  ypos;
BOOL						  Shann_Paint;
BOOL						  SH=FALSE;
extern float			  ytop;
extern int				  ybottom;
extern double			  Statist2_P[15];
extern unsigned		  xposalt;
extern unsigned		  xposShannalt;
float 					  Entropie_bed[6];
float 					  Entropie_verb[6];
float						  Hfk1, Hfk2;
extern float 			  HFK_bedingt[3][4];
float						  HFK_verbund[3][4];
float						  ETP_verbund;
float						  ETP_trans;
float						  ETP_irr;
float						  ETP_aequi;
float						  ETP_cod[11];
float						  H_theo[6];
extern float			  Schrittzahl;
float						  ETP_Buffer[4];
float						  pH[201];
float						  H1[201];
float						  H2[201];
float						  H3[201];
float						  HM[201];
float						  HM_K[3][201];
float						  pShann[201];
float						  Shann[201];
extern float			  Haeufigkeit1[36];
extern long				  Haeufigkeit2[35][35];
extern long huge		  Haeufigkeit3[35][35][35];
extern long		 		  Haeufigkeit4[4][4][4][4];
extern long		 		  Haeufigkeit5[4][4][4][4][4];
extern long				  Ausgewertet;
extern float			  HFK_Cod1[2];
extern float			  HFK_Cod2[2][2];
extern float			  HFK_Cod3[2][2][2];
extern float			  HFK_Cod4[2][2][2][2];
extern float			  HFK_Cod5[2][2][2][2][2];
extern float			  HFK_Cod6[2][2][2][2][2][2];
extern float			  HFK_Cod7[2][2][2][2][2][2][2];
extern float			  HFK_Cod8[2][2][2][2][2][2][2][2];
extern float			  HFK_Cod9[2][2][2][2][2][2][2][2][2];
extern float			  HFK_Cod10[2][2][2][2][2][2][2][2][2][2];
extern float			  HFK_Buffer[4];
extern float			  Haeufigkeit1[36];
extern long				  lLength;
extern short			  Letztes_Zeichen1, Letztes_Zeichen2, Letztes_Zeichen3, Letztes_Zeichen4;
void						  Entropie_berechnen(short Letztes_Zeichen1, short Letztes_Zeichen2,
								short Letztes_Zeichen3, short Letztes_Zeichen4);

long FAR PASCAL ETPWndProc(HWND hwnd, UINT message,
				UINT wParam, LONG lParam)
{
 PAINTSTRUCT  ps;
 HDC          hdc;
 RECT         rect, frame;
 MDICREATESTRUCT     mdicreate;
 static HWND  hwndSH, hwndShannon;
 extern int Cursorfunktion(HWND hwnd, LONG lParam, int x, int y);
 extern void  ETP_Fenstereigenschaften (HWND, HDC);
 extern void  FensterInit(HWND);
 extern void  FensterDest(HWND);
 extern void  OrdnenAufbau(HWND, char);
 extern void  OrdnenAbbau(HWND);
 extern void  Haeufigk_zaehlen(BOOL m);
 extern void  HFK_berechnen(HWND hwnd);
 extern void  ETPOPT(HWND);
 void         ETP_Paint(HDC, RECT);
 void			  ETPstat2_Berechnung(void);
 void			  ETPmark2_Berechnung(void);
 void			  ETPmark3_Berechnung(void);
 void			  Shannon(void);
 void			  Loeschen(HDC hdc);
 static HWND  hwndClient;
 int          i;


 switch(message)
  {
  case WM_CREATE:
		 hwndClient = GetParent(hwnd);
		 hwndSH=CreateWindow("button", "S(p)", WS_CHILD | WS_VISIBLE |
									BS_PUSHBUTTON, 0, 0, 0, 0, hwnd, IDC_SH, hInst, 0);
		 EnableMenuItem(hMenu, IDM_OETP, MF_GRAYED);
		 EnableMenuItem(hMenu, IDM_SETP, MF_ENABLED);
		 FensterInit(hwndClient);
		 OrdnenAufbau(hwnd, 'v');
		 Fenster.ETP = TRUE;
		 xposalt=-32000;
				 return 0;



  case WM_COMMAND:
		 switch (wParam)
	{
	case IDC_SH:

		 if(!SH)
		  {
		  GetClientRect(hwndFrame, &frame);
		  mdicreate.szClass = "SHANNON";
		  mdicreate.szTitle = "Shannonfunktion";
		  mdicreate.hOwner  = hInst;
		  mdicreate.x       = frame.right/2-137;
		  mdicreate.y       = frame.bottom/2-137;
		  mdicreate.cx      = 275;
		  mdicreate.cy      = 275;
		  mdicreate.style   = 0;
		  mdicreate.lParam  = NULL;

		  hwndShannon = (HWND) SendMessage (hwndClient, WM_MDICREATE, 0,
				 (long) (LPMDICREATESTRUCT) &mdicreate);
		  }

		  if(!Fenster.init)
			{
			SendMessage (hwndClient, WM_MDISETMENU, 0,
				MAKELONG (hMenu, hMenuWindow)) ;
			DrawMenuBar (hwnd) ;
			Fenster.init = TRUE;
			}
			break;

	}
		 break;

  case WM_SIZE:
		 xposalt=-32000;
		 GetClientRect(hwnd, &rect);
		 MoveWindow(hwndSH, rect.right-75, rect.bottom-30, 75, 30, TRUE);
		 break;//weiter mit DefMDIChildProc

  case WM_MOUSEMOVE:
		 if(HFK.ermittelt1)
		  {
		  if(Modell==3 || Modell==6 || Modell==4 || Modell==7)
			Cursorfunktion(hwnd, lParam, 0, 0);
		  }
		 return 0;

  case WM_RBUTTONDOWN:
		 ETPOPT(hwnd);
		 return 0;

  case WM_KEYDOWN:
		 return 0;

  case WM_PAINT:
		 Shann_Paint=FALSE;
		 xposalt=-32000;
		 InvalidateRect(hwnd, NULL, TRUE);
		 //erzwingt Loeschen, wg. invertiertem Strich von Cursor
		 GetClientRect(hwnd, &rect);


		 if(!Fenster.aktualisiert)
	SendMessage(GetParent(hwndClient), WM_COMMAND, IDM_RUN, 0L);
	//erzwingt Aktualisierung aller geoeffneten Fenster
	InvalidateRect(hwnd, NULL, TRUE);
	//erzwingt Loeschen, wg. invertiertem Strich von Cursor

		 if(!ETP.ermittelt1)
	{
	hdc = BeginPaint (hwnd, &ps);
	EndPaint (hwnd, &ps);
	InvalidateRect(hwnd, NULL, TRUE);
	}

		 if(!ETP.ermittelt1)
	{
	switch(Modell)
	 {
	 case 1:
			if(!HFK.ermittelt1)
			 {
			 Haeufigk_zaehlen(FALSE);
			 Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									  Letztes_Zeichen3, Letztes_Zeichen4);
			 HFK.ermittelt1 =	TRUE;
			 ETP.ermittelt1 = TRUE;
			 }
			break;

	 case 2:
			if(!HFK.ermittelt1)
			 {
			 Haeufigk_zaehlen(TRUE);
			 Entropie_verb[0]=log(4)/log(2);
			 Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									  Letztes_Zeichen3, Letztes_Zeichen4);
			 for(i=0; i<=3; i++)
			  {
			  ETP_Buffer[i]=Entropie_verb[i];
			  HFK_Buffer[i]=Haeufigkeit1[i];
			  }
			 Haeufigk_zaehlen(FALSE);
			 Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									  Letztes_Zeichen3, Letztes_Zeichen4);
			 Entropie_verb[0]=log(3)/log(2);
			 ETPstat2_Berechnung();
			 HFK_berechnen(hwnd);
			 HFK.ermittelt1 =	TRUE;
			 ETP.ermittelt1 = TRUE;
			 }
			break;

	 case 3:
			if(!HFK.ermittelt1)
			 {
			 Haeufigk_zaehlen(FALSE);
			 Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									  Letztes_Zeichen3, Letztes_Zeichen4);
			 HFK.ermittelt1 =	TRUE;
			 ETP.ermittelt1 = TRUE;
			 }
			ETPmark2_Berechnung();
			break;

	 case 4:
			if(!HFK.ermittelt1)
			 {
			 Haeufigk_zaehlen(FALSE);
			 Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									  Letztes_Zeichen3, Letztes_Zeichen4);
			 HFK.ermittelt1 =	TRUE;
			 ETP.ermittelt1 = TRUE;
			 }
			ETPmark3_Berechnung();
			break;

	 case 5:
			if(!HFK.ermittelt1)
			 {
			 Haeufigk_zaehlen(FALSE);
			 Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									  Letztes_Zeichen3, Letztes_Zeichen4);
			 HFK.ermittelt1 =	TRUE;
			 ETP.ermittelt1 = TRUE;
			 }
			break;

	 case 6:
			if(!HFK.ermittelt1)
			 {
			 Haeufigk_zaehlen(FALSE);
			 Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									  Letztes_Zeichen3, Letztes_Zeichen4);
			 HFK.ermittelt1 =	TRUE;
			 ETP.ermittelt1 = TRUE;
			 }
			ETPmark2_Berechnung();
			break;

	 case 7:
			if(!HFK.ermittelt1)
			 {
			 Haeufigk_zaehlen(FALSE);
			 Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									  Letztes_Zeichen3, Letztes_Zeichen4);
			 HFK.ermittelt1 =	TRUE;
			 ETP.ermittelt1 = TRUE;
			 }
			ETPmark3_Berechnung();
			break;

	 case 8:
			if(!HFK.ermittelt1)
			 {
			 Haeufigk_zaehlen(FALSE);
			 Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									  Letztes_Zeichen3, Letztes_Zeichen4);
			 HFK.ermittelt1 =	TRUE;
			 ETP.ermittelt1 = TRUE;
			 }
			break;

	 default:
			break;
	 }
	}//falls neue Parameter -> ETP wurde berechnet

		 hdc = BeginPaint (hwnd, &ps);
		 ETP_Fenstereigenschaften(hwnd, hdc);
		 ETP_Paint(hdc, rect);
		 EndPaint (hwnd, &ps);

		 return 0;

  case WM_DESTROY:
		 Fenster.ETP = FALSE;
		 FensterDest(hwndClient);
		 if(Fenster.neu != 0)
	OrdnenAbbau(hwndClient);
		 EnableMenuItem(hMenu, IDM_SETP, MF_GRAYED);
		 EnableMenuItem(hMenu, IDM_OETP, MF_ENABLED);
		 return 0;
  }
 return DefMDIChildProc (hwnd, message, wParam, lParam);
}


void Entropie_berechnen(short Letztes_Zeichen1, short Letztes_Zeichen2,
								short Letztes_Zeichen3, short Letztes_Zeichen4)
 {
 short				i, j, k, n, o;
 float				Warsch_bed=0;

 SetCursor(hCurWait);

 for (i=0; i<=5; i++)
  {
  Entropie_bed[i]=0;
  Entropie_verb[i]=0;
  }

if(Modell==1 || Modell==2 || Modell==5 || Modell==8)
 {
 if(Ausgewertet>2)
  {
//Entropie H3
 Haeufigkeit2[Letztes_Zeichen2][Letztes_Zeichen1]--;
 for (i=0; i<=33; i++)
  {
  for (j=0; j<=33; j++)
	{
	 Hfk1=(float)Haeufigkeit2[i][j]/(float)(Ausgewertet-2);
	for (k=0; k<=33; k++)
	 {
	  Hfk2=(float)Haeufigkeit3[i][j][k]/(float)(Ausgewertet-2);
	 if(Hfk2>0)
	  Entropie_verb[3]=Entropie_verb[3]-Hfk2*log(Hfk2)/log(2);
	 if(Hfk1>0)
	  Warsch_bed=Hfk2/Hfk1;
	 if (Warsch_bed>0)
	  Entropie_bed[3]=Entropie_bed[3]-Hfk2*log(Warsch_bed)/log(2);
	 }
	}
  }
 Haeufigkeit2[Letztes_Zeichen2][Letztes_Zeichen1]++;

//Entropie H2
 Haeufigkeit1[Letztes_Zeichen1]--;
 for (i=0; i<=33; i++)
  {
	Hfk1=(float)Haeufigkeit1[i]/(float)(Ausgewertet-1);
  for (j=0; j<=33; j++)
	{
	 Hfk2=(float)Haeufigkeit2[i][j]/(float)(Ausgewertet-1);
	if(Hfk2>0)
	 Entropie_verb[2]=Entropie_verb[2]-Hfk2*log(Hfk2)/log(2);
	if (Hfk1>0)
	 Warsch_bed=Hfk2/Hfk1;
	if (Warsch_bed>0)
	 Entropie_bed[2]=Entropie_bed[2]-Hfk2*log(Warsch_bed)/log(2);
	}
  }
 Haeufigkeit1[Letztes_Zeichen1]++;

//Entropie H1
 for (i=0; i<=33; i++)
  {
	Haeufigkeit1[i]/=(float)Ausgewertet;
  if (Haeufigkeit1[i]>0)
	Entropie_bed[1]=Entropie_bed[1]-Haeufigkeit1[i]*log(Haeufigkeit1[i])/log(2);
  Entropie_verb[1]=Entropie_bed[1];
  Haeufigkeit1[i]*=100;
  }
  }
//Entropie H0
 Haeufigkeit1[34]=Haeufigkeit1[34]*100/(float)(Ausgewertet);
 k=0;
 for(i=0; i<=33; i++)
  {
  if(Haeufigkeit1[i]>0.0)
	k++;
  }
 if(Modell==8)
  Entropie_verb[0]=log(k)/log(2);
 else if(Modell==1 || Modell==5)
  Entropie_verb[0]=log(k)/log(2);
 else if(Modell==2)
  Entropie_verb[0]=log(4)/log(2);
 }

else//Markov
 {
 if(lLength>4)
 {
//Entropie H5
 Haeufigkeit4[Letztes_Zeichen4][Letztes_Zeichen3][Letztes_Zeichen2][Letztes_Zeichen1]--;
 for (i=0; i<=2; i++)
  {
  for (j=0; j<=2; j++)
	{
	for (k=0; k<=2; k++)
	 {
	 for (n=0; n<=2; n++)
	  {
		Hfk1=(float)Haeufigkeit4[i][j][k][n]/(float)(lLength-4);
	  for (o=0; o<=2; o++)
		{
		 Hfk2=(float)Haeufigkeit5[i][j][k][n][o]/(float)(lLength-4);
		if(Hfk2>0)
		 Entropie_verb[5]=Entropie_verb[5]-Hfk2*log(Hfk2)/log(2);
		if(Hfk1>0)
		 Warsch_bed=Hfk2/Hfk1;
		if (Warsch_bed>0)
		 Entropie_bed[5]=Entropie_bed[5]-Hfk2*log(Warsch_bed)/log(2);
		}
	  }
	 }
	}
  }
 Haeufigkeit4[Letztes_Zeichen4][Letztes_Zeichen3][Letztes_Zeichen2][Letztes_Zeichen1]++;

//Entropie H4
 Haeufigkeit3[Letztes_Zeichen3][Letztes_Zeichen2][Letztes_Zeichen1]--;
 for (i=0; i<=2; i++)
  {
  for (j=0; j<=2; j++)
	{
	for (k=0; k<=2; k++)
	 {
	  Hfk1=(float)Haeufigkeit3[i][j][k]/(float)(lLength-3);
	 for (n=0; n<=2; n++)
	  {
		Hfk2=(float)Haeufigkeit4[i][j][k][n]/(float)(lLength-3);
	  if(Hfk2>0)
		Entropie_verb[4]=Entropie_verb[4]-Hfk2*log(Hfk2)/log(2);
	  if(Hfk1>0)
		Warsch_bed=Hfk2/Hfk1;
	  if (Warsch_bed>0)
		Entropie_bed[4]=Entropie_bed[4]-Hfk2*log(Warsch_bed)/log(2);
	  }
	 }
	}
  }
 Haeufigkeit3[Letztes_Zeichen3][Letztes_Zeichen2][Letztes_Zeichen1]++;

//Entropie H3
 Haeufigkeit2[Letztes_Zeichen2][Letztes_Zeichen1]--;
 for (i=0; i<=2; i++)
  {
  for (j=0; j<=2; j++)
	{
	 Hfk1=(float)Haeufigkeit2[i][j]/(float)(lLength-2);
	for (k=0; k<=2; k++)
	 {
	  Hfk2=(float)Haeufigkeit3[i][j][k]/(float)(lLength-2);
	 if(Hfk2>0)
	  Entropie_verb[3]=Entropie_verb[3]-Hfk2*log(Hfk2)/log(2);
	 if(Hfk1>0)
	  Warsch_bed=Hfk2/Hfk1;
	 if (Warsch_bed>0)
	  Entropie_bed[3]=Entropie_bed[3]-Hfk2*log(Warsch_bed)/log(2);
	 }
	}
  }
 Haeufigkeit2[Letztes_Zeichen2][Letztes_Zeichen1]++;

//Entropie H2
 Haeufigkeit1[Letztes_Zeichen1]--;
 for (i=0; i<=2; i++)
  {
	Hfk1=(float)Haeufigkeit1[i]/(float)(lLength-1);
  for (j=0; j<=2; j++)
	{
	 Hfk2=(float)Haeufigkeit2[i][j]/(float)(lLength-1);
	if(Hfk2>0)
	 Entropie_verb[2]=Entropie_verb[2]-Hfk2*log(Hfk2)/log(2);
	if (Haeufigkeit1[i]>0)
	 Warsch_bed=Hfk2/Hfk1;
	HFK_bedingt[i][j]=Warsch_bed;
	if (Warsch_bed>0)
	 Entropie_bed[2]=Entropie_bed[2]-Hfk2*log(Warsch_bed)/log(2);
	}
  }
 Haeufigkeit1[Letztes_Zeichen1]++;

//Entropie H1
  for(i=0; i<=2;i++)
	{
	 Haeufigkeit1[i]/=(float)(lLength);
	if (Haeufigkeit1[i]>0)
	 Entropie_bed[1]=Entropie_bed[1]-Haeufigkeit1[i]*log(Haeufigkeit1[i])/log(2);
	Entropie_verb[1]=Entropie_bed[1];
	Haeufigkeit1[i]*=100;
	}
//Entropie H0
  if(Modell==3 || Modell==6)
	Entropie_verb[0]=1.0;
  else
	Entropie_verb[0]=log(3)/log(2);
  }
 }

 for(i=2; i<=5;i++)
  Entropie_verb[i]/=(i);

 SetCursor(hCurArrow);
 return;
 }


void ETPmark2_Berechnung(void)
 {
 int					i, j;
 float				w[2], p, p2[4];

 memset(pH, 0, 804);
 memset(H1, 0, 804);
 memset(H2, 0, 804);
 memset(H3, 0, 804);
 memset(HM, 0, 804);
 if(pApBfest)
  {
  for(i=1; i<=200; i++)
	{
	p=0.0050*i;
	pH[i]=p;

	w[1]=p/(p+HFK_bedingt[1][0]);
	w[0]=1-w[1];

	for(j=0; j<=1; j++)
	 {
	 if(w[j]>0.0)
	  H1[i]-=w[j]*log(w[j])/log(2);
	 }
	p2[0]=w[0]*(1-p);
	p2[1]=w[0]*p;
	p2[2]=w[1]*(1-HFK_bedingt[1][0]);
	p2[3]=w[1]*HFK_bedingt[1][0];

	for(j=0; j<=3; j++)
	 {
	 if(p2[j]>0.0)
	  H2[i]-=p2[j]*log(p2[j])/log(2);
	 }
	HM[i]=H2[i]-H1[i];
	H2[i]/=2;
	H3[i]=(2*HM[i]+H1[i])/3;
	}
  pH[200]=1.0;
  }

 else if(!pApBfest)
  {
  for(i=1; i<=200; i++)
	{
	p=0.0050*i;
	pH[i]=p;

	w[1]=HFK_bedingt[0][1]/(p+HFK_bedingt[0][1]);
	w[0]=1-w[1];

	for(j=0; j<=1; j++)
	 {
	 if(w[j]>0.0)
	  H1[i]-=w[j]*log(w[j])/log(2);
	 }

	p2[0]=w[0]*(1-HFK_bedingt[0][1]);
	p2[1]=w[0]*HFK_bedingt[0][1];
	p2[2]=w[1]*p;
	p2[3]=w[1]*(1-p);

	for(j=0; j<=3; j++)
	 {
	 if(p2[j]>0.0)
	  H2[i]-=p2[j]*log(p2[j])/log(2);
	 }
	HM[i]=H2[i]-H1[i];
	H2[i]/=2;
	H3[i]=(2*HM[i]+H1[i])/3;
	}
  pH[200]=1.0;
  }

 return;
 }


void ETPmark3_Berechnung()
 {
 int					h, i, j;
 float				w[3], p, p3[9], k;

  memset(pH, 0, 804);
  memset(H1, 0, 804);
  memset(H2, 0, 804);
  memset(H3, 0, 804);
  memset(HM, 0, 804);
  memset(HM_K, 0, 2412);

  for(i=0; i<=200; i++)
	{
	if(ueber_p)
	 {
	 k=KonstMarkov;
	 p=0.0025*i;
	 pH[i]=p;
	 }
	else
	 {
	 p=pMarkov3;
	 k=0.005*i;
	 pH[i]=k;
	 }
	w[2]=(-k*p*(1-2*p)-(p-1)*(1-k*p))/((1-2*p)*(2-2*p-k*p)+k*p*(3*p-1)-(p-1)*(p+1-k*p));
	w[1]=(1-k*p-w[2]*(p+1-k*p))/(2-2*p-k*p);
	w[0]=1-w[2]-w[1];

	for(j=0; j<=2; j++)
	 {
	 if(w[j]>0.0)
	 H1[i]-=w[j]*log(w[j])/log(2);
	 }

	p3[0]=w[0]*k*p;
	p3[1]=w[0]*k*p;
	p3[2]=w[0]*(1-2*k*p);
	p3[3]=w[1]*(1-2*p);
	p3[4]=w[1]*p;
	p3[5]=w[1]*p;
	p3[6]=w[2]*p;
	p3[7]=w[2]*(1-2*p);
	p3[8]=w[2]*p;

	for(j=0; j<=8; j++)
	 {
	 if(p3[j]>0.0)
	  H2[i]-=p3[j]*log(p3[j])/log(2);
	 }
	HM[i]=H2[i]-H1[i];
	H2[i]/=2;
	H3[i]=(2*HM[i]+H1[i])/3;
	}

 for(h=0; h<=2; h++)
  {
  memset(H1, 0, 804);
  memset(H2, 0, 804);
  for(i=0; i<=200; i++)
	{
	if(ueber_p)
	 {
	 k=K[h];
	 p=0.0025*i;
	 pH[i]=p;
	 }
	else
	 {
	 p=K[h];
	 k=0.005*i;
	 pH[i]=k;
	 }
	w[2]=(-k*p*(1-2*p)-(p-1)*(1-k*p))/((1-2*p)*(2-2*p-k*p)+k*p*(3*p-1)-(p-1)*(p+1-k*p));
	w[1]=(1-k*p-w[2]*(p+1-k*p))/(2-2*p-k*p);
	w[0]=1-w[2]-w[1];

	for(j=0; j<=2; j++)
	 {
	 if(w[j]>0.0)
	 H1[i]-=w[j]*log(w[j])/log(2);
	 }

	p3[0]=w[0]*k*p;
	p3[1]=w[0]*k*p;
	p3[2]=w[0]*(1-2*k*p);
	p3[3]=w[1]*(1-2*p);
	p3[4]=w[1]*p;
	p3[5]=w[1]*p;
	p3[6]=w[2]*p;
	p3[7]=w[2]*(1-2*p);
	p3[8]=w[2]*p;

	for(j=0; j<=8; j++)
	 {
	 if(p3[j]>0.0)
	  H2[i]-=p3[j]*log(p3[j])/log(2);
	 }
	HM_K[h][i]=H2[i]-H1[i];
	H2[i]/=2;
	H3[i]=(2*HM[i]+H1[i])/3;
	}
  }


 return;
 }


void ETPstat2_Berechnung(void)
 {
 unsigned			i, j;

 for(i=0; i<=2; i++)
  {
  for(j=0; j<=3; j++)
	HFK_verbund[i][j]=0;
  }
 ETP_verbund=0;

 for(i=0; i<=lLength-1; i++)
  HFK_verbund[*(lpstrPar+i)-65][*(lpstrPar2+i)-97]++;

 for(i=0; i<=2; i++)
  {
  for(j=0; j<=3; j++)
	{
	HFK_verbund[i][j]/=(float)lLength;
	if(HFK_verbund[i][j]>0)
	 ETP_verbund=ETP_verbund-HFK_verbund[i][j]*log(HFK_verbund[i][j])/log(2);
	}
  }
 ETP_trans=Entropie_verb[1]+ETP_Buffer[1]-ETP_verbund;
 ETP_irr=ETP_Buffer[1]-ETP_trans;
 ETP_aequi=Entropie_verb[1]-ETP_trans;
 memset(H_theo, 0.0, 20);
 for(i=0; i<=2; i++)//Quellenentropie
  {
  if(Statist2_P[i]>0)
	H_theo[0]-=Statist2_P[i]*log(Statist2_P[i])/log(2);
  }
 for(i=0; i<=3; i++)//Sinkenentropie
  {
  if((Statist2_P[0]*Statist2_P[i+3]+Statist2_P[1]*Statist2_P[i+7]+Statist2_P[2]*Statist2_P[i+11])>0.0)
	H_theo[1]-=(Statist2_P[0]*Statist2_P[i+3]+Statist2_P[1]*Statist2_P[i+7]+Statist2_P[2]*Statist2_P[i+11])
				  *log(Statist2_P[0]*Statist2_P[i+3]+Statist2_P[1]*Statist2_P[i+7]+Statist2_P[2]*Statist2_P[i+11])/log(2);
  }
 for(i=0; i<=2; i++)//Verbundentropie
  {
  for(j=3; j<=6; j++)
	{
	if(Statist2_P[i]>0.0 && Statist2_P[j+i*4]>0.0)
	 H_theo[2]-=Statist2_P[i]*Statist2_P[j+i*4]*log(Statist2_P[i]*Statist2_P[j+i*4])/log(2);
	}
  }
 H_theo[3]=H_theo[0]+H_theo[1]-H_theo[2];//Transinformation
 H_theo[4]=H_theo[0]-H_theo[3];//quivokation
 H_theo[5]=H_theo[1]-H_theo[3];//Irrelevanz

 return;
 }

void Shannon(void)
 {
 int					i;
 float				p;

 memset(pShann, 0.0, 804);
 memset(Shann, 0.0, 804);
 for(i=0; i<=200; i++)
  {
  p=0.0050*i;
  pShann[i]=p;
  if(p>0 && (1-p)>0)
	Shann[i]-=p*log(p)/log(2)+(1-p)*log(1-p)/log(2);
  }

 return;
 }


void ETP_Ausgabe1_5(HDC hdc, TEXTMETRIC tm)
 {
 HBRUSH			hBrush;
 POINT			pt[4];
 unsigned		i, j, k, m, n, o, p, q, r, s;
 char				szBuffer[40];
 BYTE			   r1=0, g1=0, b1=0, r2=0, g2=0, b2=0;



//linkes Balkendiagramm
	ybottom=3*tm.tmHeight;
	xpos=-10*tm.tmAveCharWidth;
	for(i=0; i<=3; i++)
	 {
	 r1=0;
	 g1=0;
	 b1=0;
	 r2=0;
	 g2=0;
	 b2=0;
	 switch(i)
	  {
	  case 0:
			 b1=255;
			 b2=130;
			 break;
	  case 1:
			 g1=255;
			 g2=130;
			 break;
	  case 2:
			 r1=255;
			 r2=130;
			 break;
	  case 3:
			 r1=255;
			 g1=255;
			 r2=130;
			 g2=130;
			 break;
	  }
	 ytop=ybottom;
	 if(Entropie_verb[0]>0)
	  ytop=ybottom+9*tm.tmHeight*Entropie_verb[i]/Entropie_verb[0];
	 hBrush = SelectObject (hdc, CreateSolidBrush(RGB(r1, g1, b1)));
	 pt[0].x=xpos+6*tm.tmAveCharWidth;
	 pt[0].y=ybottom;
	 pt[1].x=xpos;
	 pt[1].y=ybottom;
	 pt[2].x=xpos;
	 pt[2].y=ytop;
	 pt[3].x=xpos+6*tm.tmAveCharWidth;
	 pt[3].y=ytop;
	 Polygon(hdc, pt, 4);
	 DeleteObject (SelectObject (hdc, hBrush));
	 hBrush = SelectObject (hdc, CreateSolidBrush(RGB(r2, g2, b2)));
	 pt[1].x=xpos+8*tm.tmAveCharWidth;
	 pt[1].y=ybottom+1.3*tm.tmAveCharWidth;
	 pt[2].x=xpos+8*tm.tmAveCharWidth;
	 pt[2].y=ytop+1.3*tm.tmAveCharWidth;
	 Polygon(hdc, pt, 4);
	 pt[0].x=xpos;
	 pt[0].y=ytop;
	 pt[1].x=xpos+2*tm.tmAveCharWidth;
	 pt[1].y=ytop+1.3*tm.tmAveCharWidth;
	 Polygon(hdc, pt, 4);
	 DeleteObject (SelectObject (hdc, hBrush));
	 sprintf(szBuffer, "%.3f", Entropie_verb[i]);
	 TextOut(hdc, xpos+5*tm.tmAveCharWidth, ytop+2*tm.tmHeight, szBuffer, strlen(szBuffer));
	 xpos+=6*tm.tmAveCharWidth;
	 }
	xpos=-10*tm.tmAveCharWidth;
	SetBkColor(hdc, RGB(0, 0, 255));
	SetTextColor(hdc, RGB(255, 255, 255));
	TextOut(hdc, xpos+3*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H0", 2);
	SetBkColor(hdc, RGB(0, 255, 0));
	SetTextColor(hdc, RGB(0, 0, 0));
	TextOut(hdc, xpos+9*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H1", 2);
	SetBkColor(hdc, RGB(255, 0, 0));
	SetTextColor(hdc, RGB(255, 255, 255));
	TextOut(hdc, xpos+15*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H2", 2);
	SetBkColor(hdc, RGB(255, 255, 0));
	SetTextColor(hdc, RGB(0, 0, 0));
	TextOut(hdc, xpos+21*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H3", 2);
	SetBkColor(hdc, RGB(255, 255, 255));

  SetTextColor(hdc, RGB(0, 0, 0));
  SetBkColor(hdc, RGB(0, 0, 255));
  SetTextColor(hdc, RGB(255, 255, 255));
  sprintf (szBuffer, " Quellenfolge ");
  TextOut (hdc, 2*tm.tmAveCharWidth, 2*tm.tmHeight, szBuffer, strlen (szBuffer));
  SetBkColor(hdc, RGB(255, 255, 255));
  SetTextColor(hdc, RGB(0, 0, 0));


  xpos=10*tm.tmAveCharWidth;
  ypos=2*tm.tmHeight;
  if(codiert)
	{
	memset(ETP_cod, 0.0, 44);
	for(i=0; i<=1; i++)
	 {
	 if(HFK_Cod1[i]>0.0)
	  ETP_cod[1]-=HFK_Cod1[i]/100*log(HFK_Cod1[i]/100)/log(2);
	 for(j=0; j<=1; j++)
	  {
	  if(HFK_Cod2[i][j]>0.0)
		ETP_cod[2]-=HFK_Cod2[i][j]/100*log(HFK_Cod2[i][j]/100)/log(2);
	  for(k=0; k<=1; k++)
		{
		if(HFK_Cod3[i][j][k]>0.0)
		 ETP_cod[3]-=HFK_Cod3[i][j][k]/100*log(HFK_Cod3[i][j][k]/100)/log(2);
		for(m=0; m<=1; m++)
		 {
		 if(HFK_Cod4[i][j][k][m]>0.0)
		  ETP_cod[4]-=HFK_Cod4[i][j][k][m]/100*log(HFK_Cod4[i][j][k][m]/100)/log(2);
		 for(n=0; n<=1; n++)
		  {
		  if(HFK_Cod5[i][j][k][m][n]>0.0)
			ETP_cod[5]-=HFK_Cod5[i][j][k][m][n]/100*log(HFK_Cod5[i][j][k][m][n]/100)/log(2);
		  for(o=0; o<=1; o++)
			{
			if(HFK_Cod6[i][j][k][m][n][o]>0.0)
			 ETP_cod[6]-=HFK_Cod6[i][j][k][m][n][o]/100*log(HFK_Cod6[i][j][k][m][n][o]/100)/log(2);
			for(p=0; p<=1; p++)
			 {
			 if(HFK_Cod7[i][j][k][m][n][o][p]>0.0)
			  ETP_cod[7]-=HFK_Cod7[i][j][k][m][n][o][p]/100*log(HFK_Cod7[i][j][k][m][n][o][p]/100)/log(2);
			 for(q=0; q<=1; q++)
			  {
			  if(HFK_Cod8[i][j][k][m][n][o][p][q]>0.0)
				ETP_cod[8]-=HFK_Cod8[i][j][k][m][n][o][p][q]/100*log(HFK_Cod8[i][j][k][m][n][o][p][q]/100)/log(2);
			  for(r=0; r<=1; r++)
				{
				if(HFK_Cod9[i][j][k][m][n][o][p][q][r]>0.0)
				 ETP_cod[9]-=HFK_Cod9[i][j][k][m][n][o][p][q][r]/100*log(HFK_Cod9[i][j][k][m][n][o][p][q][r]/100)/log(2);
				for(s=0; s<=1; s++)
				 {
				 if(HFK_Cod10[i][j][k][m][n][o][p][q][r][s]>0.0)
				  ETP_cod[10]-=HFK_Cod10[i][j][k][m][n][o][p][q][r][s]/100*log(HFK_Cod10[i][j][k][m][n][o][p][q][r][s]/100)/log(2);
				 }
				}
			  }
			 }
			}
		  }
		 }
		}
	  }
	 }
	ETP_cod[0]=1.0;
	ETP_cod[2]/=2.0;
	ETP_cod[3]/=3.0;
	ETP_cod[4]/=4.0;
	ETP_cod[5]/=5.0;
	ETP_cod[6]/=6.0;
	ETP_cod[7]/=7.0;
	ETP_cod[8]/=8.0;
	ETP_cod[9]/=9.0;
	ETP_cod[10]/=10.0;


//rechtes Balkendiagramm
	ybottom=3*tm.tmHeight;
	xpos=17*tm.tmAveCharWidth;
	for(i=0; i<=10; i++)
	 {
	 r1=0;
	 g1=0;
	 b1=0;
	 r2=0;
	 g2=0;
	 b2=0;
	 switch(i)
	  {
	  case 0:
			 b1=255;
			 b2=130;
			 break;
	  case 1:
			 g1=255;
			 g2=130;
			 break;
	  case 2:
			 r1=255;
			 r2=130;
			 break;
	  case 3:
			 r1=255;
			 g1=255;
			 r2=130;
			 g2=130;
			 break;
	  case 4:
			 r1=255;
			 b1=255;
			 r2=130;
			 b2=130;
			 break;
	  case 5:
			 g1=255;
			 b1=255;
			 g2=130;
			 b2=130;
			 break;
	  case 6:
			 b1=255;
			 b2=130;
			 break;
	  case 7:
			 g1=255;
			 g2=130;
			 break;
	  case 8:
			 r1=255;
			 r2=130;
			 break;
	  case 9:
			 r1=255;
			 g1=255;
			 r2=130;
			 g2=130;
			 break;
	  case 10:
			 r1=255;
			 b1=255;
			 r2=130;
			 b2=130;
			 break;
	  }
	 ytop=ybottom;
	 if(Entropie_verb[0]>0)
	  ytop=ybottom+9*tm.tmHeight*ETP_cod[i]/Entropie_verb[0];
	 hBrush = SelectObject (hdc, CreateSolidBrush(RGB(r1, g1, b1)));
	 pt[0].x=xpos+6*tm.tmAveCharWidth;
	 pt[0].y=ybottom;
	 pt[1].x=xpos;
	 pt[1].y=ybottom;
	 pt[2].x=xpos;
	 pt[2].y=ytop;
	 pt[3].x=xpos+6*tm.tmAveCharWidth;
	 pt[3].y=ytop;
	 Polygon(hdc, pt, 4);
	 DeleteObject (SelectObject (hdc, hBrush));
	 hBrush = SelectObject (hdc, CreateSolidBrush(RGB(r2, g2, b2)));
	 pt[1].x=xpos+8*tm.tmAveCharWidth;
	 pt[1].y=ybottom+1.3*tm.tmAveCharWidth;
	 pt[2].x=xpos+8*tm.tmAveCharWidth;
	 pt[2].y=ytop+1.3*tm.tmAveCharWidth;
	 Polygon(hdc, pt, 4);
	 pt[0].x=xpos;
	 pt[0].y=ytop;
	 pt[1].x=xpos+2*tm.tmAveCharWidth;
	 pt[1].y=ytop+1.3*tm.tmAveCharWidth;
	 Polygon(hdc, pt, 4);
	 DeleteObject (SelectObject (hdc, hBrush));
	 sprintf(szBuffer, "%.3f", ETP_cod[i]);
	 TextOut(hdc, xpos+5*tm.tmAveCharWidth, ytop+2*tm.tmHeight, szBuffer, strlen(szBuffer));
	 xpos+=6*tm.tmAveCharWidth;
	 }
	xpos=17*tm.tmAveCharWidth;
	SetBkColor(hdc, RGB(0, 0, 255));
	SetTextColor(hdc, RGB(255, 255, 255));
	TextOut(hdc, xpos+3*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H0", 2);
	SetBkColor(hdc, RGB(0, 255, 0));
	SetTextColor(hdc, RGB(0, 0, 0));
	TextOut(hdc, xpos+9*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H1", 2);
	SetBkColor(hdc, RGB(255, 0, 0));
	SetTextColor(hdc, RGB(255, 255, 255));
	TextOut(hdc, xpos+15*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H2", 2);
	SetBkColor(hdc, RGB(255, 255, 0));
	SetTextColor(hdc, RGB(0, 0, 0));
	TextOut(hdc, xpos+21*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H3", 2);
	SetBkColor(hdc, RGB(255, 0, 255));
	SetTextColor(hdc, RGB(255, 255, 255));
	TextOut(hdc, xpos+27*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H4", 2);
	SetBkColor(hdc, RGB(0, 255, 255));
	SetTextColor(hdc, RGB(0, 0, 0));
	TextOut(hdc, xpos+33*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H5", 2);
	SetBkColor(hdc, RGB(0, 0, 255));
	SetTextColor(hdc, RGB(255, 255, 255));
	TextOut(hdc, xpos+39*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H6", 2);
	SetBkColor(hdc, RGB(0, 255, 0));
	SetTextColor(hdc, RGB(0, 0, 0));
	TextOut(hdc, xpos+45*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H7", 2);
	SetBkColor(hdc, RGB(255, 0, 0));
	SetTextColor(hdc, RGB(255, 255, 255));
	TextOut(hdc, xpos+51*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H8", 2);
	SetBkColor(hdc, RGB(255, 255, 0));
	SetTextColor(hdc, RGB(0, 0, 0));
	TextOut(hdc, xpos+57*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H9", 2);
	SetBkColor(hdc, RGB(255, 0, 255));
	SetTextColor(hdc, RGB(255, 255, 255));
	TextOut(hdc, xpos+63*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H10", 3);
	SetBkColor(hdc, RGB(255, 255, 255));
	SetBkColor(hdc, RGB(255, 0, 0));
	SetTextColor(hdc, RGB(255, 255, 255));
	sprintf (szBuffer, " Codefolge ");
	TextOut (hdc, 29*tm.tmAveCharWidth, 2*tm.tmHeight, szBuffer, strlen (szBuffer));
	SetBkColor(hdc, RGB(255, 255, 255));
	SetTextColor(hdc, RGB(0, 0, 0));
	sprintf(szBuffer, "Mittlere Codewortlnge L= %.4f", Schrittzahl);
	TextOut(hdc, 15*tm.tmAveCharWidth, 0, szBuffer, strlen(szBuffer));
	}

 return;
 }


void ETP_Ausgabe2(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 static HANDLE	hMF;
 POINT			point;
 char				szBuffer[20];
 void				Arrow(HDC hdc, TEXTMETRIC tm, int x, int y, float a, float b,
							  float c, float d, float e, float f, float g, float h);


 hMF=GetMetaFile("entropie.wmf");
 PlayMetaFile(hdc, hMF);
 DeleteMetaFile(hMF);
 GetTextMetrics(hdc,&tm);

 point.x=.15*rect.right;
 point.y=.4*rect.bottom;
 DPtoLP (hdc, (LPPOINT) &point, 1);
 sprintf(szBuffer, "H(q)= %.4f", Entropie_verb[1]);
 TextOut(hdc, point.x, point.y, szBuffer, strlen(szBuffer));
 LPtoDP (hdc, (LPPOINT) &point, 1);
 point.x=.5*rect.right;
 DPtoLP (hdc, (LPPOINT) &point, 1);
 sprintf(szBuffer, "HT= %.4f", ETP_trans);
 TextOut(hdc, point.x, point.y, szBuffer, strlen(szBuffer));
 LPtoDP (hdc, (LPPOINT) &point, 1);
 point.x=.85*rect.right;
 DPtoLP (hdc, (LPPOINT) &point, 1);
 sprintf(szBuffer, "H(v)= %.4f", ETP_Buffer[1]);
 TextOut(hdc, point.x, point.y, szBuffer, strlen(szBuffer));
 point.x=.3*rect.right;
 point.y=.85*rect.bottom;
 DPtoLP (hdc, (LPPOINT) &point, 1);
 point.y-=tm.tmHeight;
 sprintf(szBuffer, "H(q|v)= %.4f", ETP_aequi);
 TextOut(hdc, point.x, point.y, szBuffer, strlen(szBuffer));
 point.x=.7*rect.right;
 point.y=.2*rect.bottom;
 DPtoLP (hdc, (LPPOINT) &point, 1);
 sprintf(szBuffer, "H(v|q)= %.4f", ETP_irr);
 TextOut(hdc, point.x, point.y, szBuffer, strlen(szBuffer));

 SetBkColor(hdc, RGB(0, 0, 0));
 SetTextColor(hdc, RGB(255, 255, 255));
 point.x=.15*rect.right;
 point.y=.4*rect.bottom;
 DPtoLP (hdc, (LPPOINT) &point, 1);
 point.y+=tm.tmHeight;
 sprintf(szBuffer, "H(q)= %.4f", H_theo[0]);
 TextOut(hdc, point.x, point.y, szBuffer, strlen(szBuffer));
 LPtoDP (hdc, (LPPOINT) &point, 1);
 point.x=.5*rect.right;
 DPtoLP (hdc, (LPPOINT) &point, 1);
 sprintf(szBuffer, "HT= %.4f", H_theo[3]);
 TextOut(hdc, point.x, point.y, szBuffer, strlen(szBuffer));
 LPtoDP (hdc, (LPPOINT) &point, 1);
 point.x=.85*rect.right;
 DPtoLP (hdc, (LPPOINT) &point, 1);
 sprintf(szBuffer, "H(v)= %.4f", H_theo[1]);
 TextOut(hdc, point.x, point.y, szBuffer, strlen(szBuffer));
 point.x=.3*rect.right;
 point.y=.85*rect.bottom;
 DPtoLP (hdc, (LPPOINT) &point, 1);
 sprintf(szBuffer, "H(q|v)= %.4f", H_theo[4]);
 TextOut(hdc, point.x, point.y, szBuffer, strlen(szBuffer));
 point.x=.7*rect.right;
 point.y=.2*rect.bottom;
 DPtoLP (hdc, (LPPOINT) &point, 1);
 point.y+=tm.tmHeight;
 sprintf(szBuffer, "H(v|q)= %.4f", H_theo[5]);
 TextOut(hdc, point.x, point.y, szBuffer, strlen(szBuffer));

 SetTextAlign(hdc, TA_LEFT);
 SetBkColor(hdc, RGB(0, 0, 0));
 SetTextColor(hdc, RGB(255, 255, 255));
 point.x=rect.left;
 point.y=rect.top;
 DPtoLP (hdc, (LPPOINT) &point, 1);
 TextOut(hdc, point.x, point.y, "Entropiewerte nach theoretischen Wahrscheinlichkeiten", 53);
 SetBkColor(hdc, RGB(255, 255, 255));
 SetTextColor(hdc, RGB(0, 0, 0));
 point.y-=tm.tmHeight;
 TextOut(hdc, point.x, point.y, "Entropiewerte aus Simulation", 28);

 return;
 }


void ETP_Ausgabe3_6(HDC hdc, TEXTMETRIC tm)
 {
 int					i;
 void					Koordinatensystem(HDC hdc, TEXTMETRIC tm, int x, int y);
 extern void		ETP_Ausgabe(HDC, TEXTMETRIC, int, int, unsigned);

	Koordinatensystem(hdc, tm, 0, 0);
	SetTextAlign(hdc, TA_LEFT);
	ETP_Ausgabe(hdc, tm, 0, 0, 0);

	hPen = SelectObject (hdc, CreatePen (PS_SOLID, 38, RGB(0, 0, 150)));
	MoveTo(hdc, 0, H1[1]*9200);
	for(i=0; i<=200; i++)
	 {
	 xpos=46*i;
	 ypos=H1[i]*9200;
	 LineTo(hdc, xpos, ypos);
	 }
	DeleteObject (SelectObject (hdc, hPen));

	hPen = SelectObject (hdc, CreatePen (PS_SOLID, 38, RGB(150, 0, 0)));
	MoveTo(hdc, 0, H2[1]*9200);
	for(i=1; i<=200; i++)
	 {
	 xpos=46*i;
	 ypos=H2[i]*9200;
	 LineTo(hdc, xpos, ypos);
	 }
	DeleteObject (SelectObject (hdc, hPen));

	hPen = SelectObject (hdc, CreatePen (PS_SOLID, 38, RGB(150, 150, 0)));
	MoveTo(hdc, 0, H3[1]*9200);
	for(i=1; i<=200; i++)
	 {
	 xpos=46*i;
	 ypos=H3[i]*9200;
	 LineTo(hdc, xpos, ypos);
	 }
	DeleteObject (SelectObject (hdc, hPen));

	hPen = SelectObject (hdc, CreatePen (PS_SOLID, 38, RGB(0, 150, 0)));
	MoveTo(hdc, 0, HM[1]*9200);
	for(i=1; i<=200; i++)
	 {
	 xpos=46*i;
	 ypos=HM[i]*9200;
	 LineTo(hdc, xpos, ypos);
	 }
	DeleteObject (SelectObject (hdc, hPen));

 return;
 }


void ETP_Ausgabe4_7(HDC hdc, TEXTMETRIC tm)
 {
 char					szBuffer[40];
 int					i;
 void					Koordinatensystem(HDC hdc, TEXTMETRIC tm, int x, int y);
 extern void		ETP_Ausgabe(HDC, TEXTMETRIC, int, int, unsigned);

	Koordinatensystem(hdc, tm, 0, 0);
	SetTextAlign(hdc, TA_LEFT);
	ETP_Ausgabe(hdc, tm, 0, 0, 0);

	hPen = SelectObject (hdc, CreatePen (PS_SOLID, 38, RGB(0, 0, 150)));
	MoveTo(hdc, 0, HM[0]*6000);
	for(i=0; i<=200; i++)
	 {
	 xpos=46*i;
	 ypos=HM[i]*6000;
	 LineTo(hdc, xpos, ypos);
	 }
	DeleteObject (SelectObject (hdc, hPen));

	hPen = SelectObject (hdc, CreatePen (PS_SOLID, 38, RGB(150, 0, 0)));
	MoveTo(hdc, 0, HM_K[0][0]*6000);
	for(i=1; i<=200; i++)
	 {
	 xpos=46*i;
	 ypos=HM_K[0][i]*6000;
	 LineTo(hdc, xpos, ypos);
	 }
	DeleteObject (SelectObject (hdc, hPen));

	hPen = SelectObject (hdc, CreatePen (PS_SOLID, 38, RGB(150, 150, 0)));
	MoveTo(hdc, 0, HM_K[1][0]*6000);
	for(i=1; i<=200; i++)
	 {
	 xpos=46*i;
	 ypos=HM_K[1][i]*6000;
	 LineTo(hdc, xpos, ypos);
	 }
	DeleteObject (SelectObject (hdc, hPen));

	hPen = SelectObject (hdc, CreatePen (PS_SOLID, 38, RGB(0, 150, 0)));
	MoveTo(hdc, 0, HM_K[2][0]*6000);
	for(i=1; i<=200; i++)
	 {
	 xpos=46*i;
	 ypos=HM_K[2][i]*6000;
	 LineTo(hdc, xpos, ypos);
	 }
	DeleteObject (SelectObject (hdc, hPen));

	SetTextColor(hdc, RGB(0, 0, 150));
	if(ueber_p)
	 sprintf(szBuffer, "k= %.4f", KonstMarkov);
	else
	 sprintf(szBuffer, "p= %.4f", pMarkov3);
	TextOut(hdc, 10000, 5000, szBuffer, strlen(szBuffer));
	SetTextColor(hdc, RGB(150, 0, 0));
	if(ueber_p)
	 sprintf(szBuffer, "k= %.4f", K[0]);
	else
	 sprintf(szBuffer, "p= %.4f", K[0]);
	TextOut(hdc, 10000, 5000-tm.tmHeight, szBuffer, strlen(szBuffer));
	SetTextColor(hdc, RGB(150, 150, 0));
	if(ueber_p)
	 sprintf(szBuffer, "k= %.4f", K[1]);
	else
	 sprintf(szBuffer, "p= %.4f", K[1]);
	TextOut(hdc, 10000, 5000-2*tm.tmHeight, szBuffer, strlen(szBuffer));
	SetTextColor(hdc, RGB(0, 150, 0));
	if(ueber_p)
	 sprintf(szBuffer, "k= %.4f", K[2]);
	else
	 sprintf(szBuffer, "p= %.4f", K[2]);
	TextOut(hdc, 10000, 5000-3*tm.tmHeight, szBuffer, strlen(szBuffer));

 return;
 }


void ETP_Ausgabe8(HDC hdc, TEXTMETRIC tm)
 {
 HBRUSH			hBrush;
 POINT			pt[4];
 int				i;
 char				szBuffer[10];
 BYTE			  r1=0, g1=0, b1=0, r2=0, g2=0, b2=0;

	ybottom=0;
	xpos=0;
	for(i=0; i<=3; i++)
	 {
	 r1=0;
	 g1=0;
	 b1=0;
	 r2=0;
	 g2=0;
	 b2=0;
	 switch(i)
	  {
	  case 0:
			 b1=255;
			 b2=130;
			 break;
	  case 1:
			 g1=255;
			 g2=130;
			 break;
	  case 2:
			 r1=255;
			 r2=130;
			 break;
	  case 3:
			 r1=255;
			 g1=255;
			 r2=130;
			 g2=130;
			 break;
	  }
	 ytop=ybottom;
	 if(Entropie_verb[0]>0)
	  ytop=12*tm.tmHeight*Entropie_verb[i]/Entropie_verb[0];
	 hBrush = SelectObject (hdc, CreateSolidBrush(RGB(r1, g1, b1)));
	 pt[0].x=xpos+6*tm.tmAveCharWidth;
	 pt[0].y=ybottom;
	 pt[1].x=xpos;
	 pt[1].y=ybottom;
	 pt[2].x=xpos;
	 pt[2].y=ytop;
	 pt[3].x=xpos+6*tm.tmAveCharWidth;
	 pt[3].y=ytop;
	 Polygon(hdc, pt, 4);
	 DeleteObject (SelectObject (hdc, hBrush));
	 hBrush = SelectObject (hdc, CreateSolidBrush(RGB(r2, g2, b2)));
	 pt[1].x=xpos+8*tm.tmAveCharWidth;
	 pt[1].y=ybottom+1.3*tm.tmAveCharWidth;
	 pt[2].x=xpos+8*tm.tmAveCharWidth;
	 pt[2].y=ytop+1.3*tm.tmAveCharWidth;
	 Polygon(hdc, pt, 4);
	 pt[0].x=xpos;
	 pt[0].y=ytop;
	 pt[1].x=xpos+2*tm.tmAveCharWidth;
	 pt[1].y=ytop+1.3*tm.tmAveCharWidth;
	 Polygon(hdc, pt, 4);
	 DeleteObject (SelectObject (hdc, hBrush));
	 sprintf(szBuffer, "%.3f", Entropie_verb[i]);
	 TextOut(hdc, xpos+5*tm.tmAveCharWidth, ytop+2*tm.tmHeight, szBuffer, strlen(szBuffer));
	 xpos+=6*tm.tmAveCharWidth;
	 }
	xpos=0;
	SetBkColor(hdc, RGB(0, 0, 255));
	SetTextColor(hdc, RGB(255, 255, 255));
	TextOut(hdc, xpos+3*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H0", 2);
	SetBkColor(hdc, RGB(0, 255, 0));
	SetTextColor(hdc, RGB(0, 0, 0));
	TextOut(hdc, xpos+9*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H1", 2);
	SetBkColor(hdc, RGB(255, 0, 0));
	SetTextColor(hdc, RGB(255, 255, 255));
	TextOut(hdc, xpos+15*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H2", 2);
	SetBkColor(hdc, RGB(255, 255, 0));
	SetTextColor(hdc, RGB(0, 0, 0));
	TextOut(hdc, xpos+21*tm.tmAveCharWidth, ybottom+tm.tmHeight, "H3", 2);

 return;
 }


void Arrow(HDC hdc, TEXTMETRIC tm, int x, int y, float a, float b, float c, float d,
			  float e, float f, float g, float h)
 {
 HBRUSH			hBrush;
 POINT			pt[4];

	 pt[0].x=x+a*tm.tmHeight;
	 pt[0].y=y+b*tm.tmHeight;
	 pt[1].x=x+c*tm.tmHeight;
	 pt[1].y=y+d*tm.tmHeight;
	 pt[2].x=x+e*tm.tmHeight;
	 pt[2].y=y+f*tm.tmHeight;
	 pt[3].x=x+g*tm.tmHeight;
	 pt[3].y=y+h*tm.tmHeight;
	 hBrush = SelectObject (hdc, CreateSolidBrush(RGB(0, 0, 0)));
	 Polygon(hdc, pt, 4);
	 DeleteObject (SelectObject (hdc, hBrush));

 return;
 }


void ETP_Paint(HDC hdc, RECT rect)
{
 TEXTMETRIC		tm;
 void						ETP_Ausgabe1_5(HDC hdc, TEXTMETRIC tm);
 void						ETP_Ausgabe2(HDC hdc, RECT rect, TEXTMETRIC tm);
 void						ETP_Ausgabe3_6(HDC hdc, TEXTMETRIC tm);
 void						ETP_Ausgabe4_7(HDC hdc, TEXTMETRIC tm);
 void						ETP_Ausgabe8(HDC hdc, TEXTMETRIC tm);

 GetTextMetrics(hdc,&tm);

 SetTextAlign(hdc, TA_CENTER);

 switch(Modell)
  {
  case 1:
		 ETP_Ausgabe1_5(hdc, tm);

		 break;

  case 2:
		 ETP_Ausgabe2(hdc, rect, tm);

		 break;

  case 3:
		 ETP_Ausgabe3_6(hdc, tm);

		 break;

  case 4:
		 ETP_Ausgabe4_7(hdc, tm);

		 break;

  case 5:
		 ETP_Ausgabe1_5(hdc, tm);

		 break;

  case 6:
		 ETP_Ausgabe3_6(hdc, tm);

		 break;

  case 7:
		 ETP_Ausgabe4_7(hdc, tm);

		 break;

  case 8:
		 ETP_Ausgabe8(hdc, tm);

		 break;

  }

 return;
}


void Koordinatensystem(HDC hdc, TEXTMETRIC tm, int x, int y)
 {
 short			i;
 char				buf[11];
 void				Arrow(HDC hdc, TEXTMETRIC tm, int x, int y, float a, float b,
							  float c, float d, float e, float f, float g, float h);

//Koordinatensystem zeichnen
 MoveTo(hdc, x, y);
 LineTo(hdc, x+10500, y);
 MoveTo(hdc, x, y);
 LineTo(hdc, x, y+10500);
 if(Modell==4 || Modell==7)
  {
  for(i=0; i<=5; i++)
	{
	MoveTo(hdc, x+1840*i, y+150);
	LineTo(hdc, x+1840*i, y-150);
	}
  for(i=0; i<=8; i++)
	{
	MoveTo(hdc, x-150, y+1200*i);
	LineTo(hdc, x+150, y+1200*i);
	}
  for(i=1; i<=9; i+=2)
	{
	MoveTo(hdc, x+920*i, y+100);
	LineTo(hdc, x+920*i, y-100);
	}
  for(i=1; i<=15; i+=2)
	{
	MoveTo(hdc, x-100, y+600*i);
	LineTo(hdc, x+100, y+600*i);
	}
  }
 else
  {
  for(i=0; i<=5; i++)
	{
	MoveTo(hdc, x+1840*i, y+150);
	LineTo(hdc, x+1840*i, y-150);
	MoveTo(hdc, x-150, y+1840*i);
	LineTo(hdc, x+150, y+1840*i);
	}
  for(i=1; i<=9; i+=2)
	{
	MoveTo(hdc, x+920*i, y+100);
	LineTo(hdc, x+920*i, y-100);
	MoveTo(hdc, x-100, y+920*i);
	LineTo(hdc, x+100, y+920*i);
	}
  }
 Arrow(hdc, tm, x, y+10500, 0, 0, -.25, -1, 0, -.5, .25, -1);
 Arrow(hdc, tm, x+10500, y, 0, 0, -1, .25, -.5, 0, -1, -.25);

//Achsenbeschriftung
  SetMapperFlags (hdc, 1L);
  lf.lfPitchAndFamily=DEFAULT_PITCH | FF_ROMAN;
  lf.lfHeight =700;
  hFont = SelectObject (hdc, CreateFontIndirect (&lf));
  GetTextMetrics (hdc, &tm);
  sprintf(buf, "0");
  TextOut(hdc, x-150, y-150, buf, strlen(buf));
  if(Modell==4 || Modell==7)
	{
	for(i=1; i<=5; i++)
	 {
	 if(ueber_p)
	  {
	  sprintf(buf, "%.1f", i*0.1);
	  TextOut(hdc, x+1840*i, y-150, buf, strlen(buf));
	  }
	 else
	  {
	  sprintf(buf, "%.1f", i*0.2);
	  TextOut(hdc, x+1840*i, y-150, buf, strlen(buf));
	  }
	 }
	for(i=1; i<=8; i++)
	 {
	 sprintf(buf, "%.1f", i*0.2);
	 TextOut(hdc, x-850, y+1200*i+tm.tmHeight/2, buf, strlen(buf));
	 }
	}
  else
	{
	for(i=1; i<=5; i++)
	 {
	 sprintf(buf, "%.1f", i*0.2);
	 TextOut(hdc, x+1840*i, y-150, buf, strlen(buf));
	 TextOut(hdc, x-850, y+1840*i+tm.tmHeight/2, buf, strlen(buf));
	 }
	}
  if(Modell==3 || Modell==6)
	{
	if(pApBfest)
	 {
	 sprintf(buf, "p(B|A)");
	 TextOut(hdc, x+10500, y-200, buf, strlen(buf));
	 }
	else
	 {
	 sprintf(buf, "p(A|B)");
	 TextOut(hdc, x+10500, y-200, buf, strlen(buf));
	 }
	}

  else
	{
	if(ueber_p)
	 sprintf(buf, "p");
	else
	 sprintf(buf, "k");
	TextOut(hdc, x+10500, y-150, buf, strlen(buf));
	}

  if(Shann_Paint)
	 {
	 sprintf(buf, "p         ");
	 TextOut(hdc, x+10500, y-200, buf, strlen(buf));
	 }

  DeleteObject(SelectObject(hdc, hFont));

 return;
 }



long FAR PASCAL SHWndProc(HWND hwnd, UINT message,
				UINT wParam, LONG lParam)
{
 PAINTSTRUCT  ps;
 HDC          hdc;
 TEXTMETRIC	  tm;
 int          i;
 unsigned	  xposShann;
 unsigned	  yposShann;
 extern void  Shannon_Fenstereigenschaften (HWND, HDC);
 extern void  FensterInit(HWND);
 extern void  FensterDest(HWND);
 extern void  OrdnenAufbau(HWND, char);
 extern void  OrdnenAbbau(HWND);
 void				Koordinatensystem(HDC hdc, TEXTMETRIC tm, int x, int y);
 extern int CursorShannon(HWND hwnd, LONG lParam, int x, int y);


 switch(message)
  {
  case WM_CREATE:
				 SH=TRUE;
				 xposShannalt=-32000;
		 return 0;

  case WM_SYSCOMMAND:
		if(wParam == SC_MINIMIZE)
		 SetWindowText(hwnd, "Shannonfunktion");
		 break;

  case WM_SIZE:
		 xposShannalt=-32000;
		 break;

  case WM_MOUSEMOVE:
			CursorShannon(hwnd, lParam, 0, 0);
		 return 0;

  case WM_KEYDOWN:
		 return 0;

  case WM_PAINT:
		Shann_Paint=TRUE;
		 xposShannalt=-32000;
		 InvalidateRect(hwnd, NULL, TRUE);
	hdc = BeginPaint (hwnd, &ps);
	Shannon_Fenstereigenschaften (hwnd, hdc);
	GetTextMetrics(hdc,&tm);
	Koordinatensystem(hdc, tm, 0, 0);
			hPen = SelectObject (hdc, CreatePen (PS_SOLID, 38, RGB(0, 0, 150)));
			MoveTo(hdc, 0, 0);
			for(i=1; i<=200; i++)
			 {
			 xposShann=46*i;
			 yposShann=Shann[i]*9200;
			 LineTo(hdc, xposShann, yposShann);
			 }
			DeleteObject (SelectObject (hdc, hPen));
	EndPaint (hwnd, &ps);
		 return 0;

  case WM_DESTROY:
			  SH=FALSE;
		 return 0;
  }
 return DefMDIChildProc (hwnd, message, wParam, lParam);
}
