//-------------------------------------------------------------------------
//------------------------------- HFK_WND.C -------------------------------
//-------------------------------------------------------------------------
//----- Fensterfunktion Hufigkeit "Wertdiskrete Informationstheorie" -----
//-------------------- Erstellt von: Georg Delle --------------------------


#include <windows.h>
#include <math.h>
#include <stdlib.h>
#include <io.h>
#include <string.h>
#include <stdio.h>
#include <commdlg.h>
#include "wdit.h"
#include "wdit_typ.h"

#define xlinks -7500
#define ywertneg_cursor 0
#define ywertpos_cursor 1
#define yunten -8000
#define yoben 5500
#define ynorm_lin 12500

extern LPSTR			  lpstrPar;
extern LPSTR			  lpstrPar2;
extern LPSTR			  lpstrCod;
LPSTR				        lpstrBuffer;
HANDLE        			  hBuffer;
extern HMENU           hMenu;
extern HANDLE          hInst;
extern HWND            hwndFrame;
extern RECT				  rect;
extern HCURSOR         hCurWait, hCurArrow;
extern STRUCT_FENSTER  Fenster;
extern STRUCT_TOCHTER  ETP, HFK;
extern STRUCT_DATEI    Datei1, Datei2;
extern STRUCT_PUNKT    ptHFK1[101], ptHFK2[101];
extern short			  Modell;
extern float			  Schrittzahl;
extern float			  ETP_Buffer[4];
extern BOOL				  VorNach2;
extern BOOL				  VorNach3;
extern BOOL				  OhneZI;
extern BOOL				  OhneLZ;
extern BOOL				  OhneIP;
extern BOOL				  OhneSZ;
extern BOOL				  codiert;
extern BOOL				  decodiert;
extern float			  HFK_verbund[3][4];
float						  HFK_bedingt[3][4];
float						  HFK_rueck[3][4];
float						  HFK_Buffer[4];
BOOL                   HFK_erneuernd=FALSE;
char						  szBuffer[25];
char						  Alphabet[35][4];
extern char				  Zeich[3][9];
int						  xpos;
int						  ypos;
float						  ytop;
int						  ybottom;
float						  Hoehe;
float						  Array[35];
extern float			  HFK_Cod1[2];
extern long				  lLength;
float						  Haeufigkeit1[36];
long						  Haeufigkeit2[35][35];
long huge				  Haeufigkeit3[35][35][35];
long						  Haeufigkeit4[4][4][4][4];
long						  Haeufigkeit5[4][4][4][4][4];
long						  Ausgewertet;
short						  Letztes_Zeichen1, Letztes_Zeichen2, Letztes_Zeichen3, Letztes_Zeichen4;
extern float			  Entropie_verb[6];
extern void				  Entropie_berechnen(short Letztes_Zeichen1, short Letztes_Zeichen2,
								short Letztes_Zeichen3, short Letztes_Zeichen4);
long	a;

long FAR PASCAL HFKWndProc(HWND hwnd, UINT message,
				UINT wParam, LONG lParam)
{
 PAINTSTRUCT  ps;
 HDC          hdc;
 HMENU		  hPopupMenu;
 RECT         rect;
 void         Haeufigk_zaehlen(BOOL m);
 extern void  HFKOPT(HWND);
 extern void  ETPstat2_Berechnung(void);
 extern void  ETPmark2_Berechnung(void);
 extern void  ETPmark3_Berechnung(void);
 void			  HFK_berechnen(void);
 void         HFK_Paint(HDC, RECT);

 extern void  Fenstereigenschaften (HWND, HDC);
 extern void  FensterInit(HWND);
 extern void  FensterDest(HWND);
 extern void  OrdnenAufbau(HWND, char);
 extern void  OrdnenAbbau(HWND);
 static HWND  hwndClient;
 int			  i;
 switch(message)
  {
  case WM_CREATE:
		 hwndClient = GetParent(hwnd);
		 EnableMenuItem(hMenu, IDM_OHFK, MF_GRAYED);
		 EnableMenuItem(hMenu, IDM_SHFK, MF_ENABLED);
		 FensterInit(hwndClient);
		 OrdnenAufbau(hwnd, 'k');
		 Fenster.HFK = TRUE;
		 return 0;

  case WM_COMMAND:
		 switch (wParam)
	{
	}
		 break;

  case WM_PAINT:
		 GetClientRect(hwnd, &rect);

		 if(!Fenster.aktualisiert)
	SendMessage(GetParent(hwndClient), WM_COMMAND, IDM_RUN, 0L);
	//erzwingt Aktualisierung aller geoeffneten Fenster

		 if(Fenster.aktualisiert && Modell==8)
		  {
		  hPopupMenu=GetSubMenu(hMenu, 2);
		  AppendMenu(hPopupMenu, MF_ENABLED, IDM_HAEUFIG, (LPSTR) "&Hufigkeiten speichern...");
		  }



		 if(!HFK.ermittelt1)
	{
	hdc = BeginPaint (hwnd, &ps);
	EndPaint (hwnd, &ps);
	InvalidateRect(hwnd, NULL, TRUE);
	}

		 if(!HFK.ermittelt1)
	{
	switch(Modell)
	 {
	 case 1:
			Haeufigk_zaehlen(FALSE);
			Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									 Letztes_Zeichen3, Letztes_Zeichen4);
			break;

	 case 2:
			Haeufigk_zaehlen(TRUE);
			Entropie_verb[0]=log(4)/log(2);
			Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									 Letztes_Zeichen3, Letztes_Zeichen4);
			for(i=0; i<=3; i++)
			 {
			 ETP_Buffer[i]=Entropie_verb[i];
			 HFK_Buffer[i]=Haeufigkeit1[i];
			 }
			Haeufigk_zaehlen(FALSE);
			Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									 Letztes_Zeichen3, Letztes_Zeichen4);
			Entropie_verb[0]=log(3)/log(2);
			ETPstat2_Berechnung();
			HFK_berechnen();
			break;

	 case 3:
			Haeufigk_zaehlen(FALSE);
			Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									 Letztes_Zeichen3, Letztes_Zeichen4);
			ETPmark2_Berechnung();
			break;

	 case 4:
			Haeufigk_zaehlen(FALSE);
			Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									 Letztes_Zeichen3, Letztes_Zeichen4);
			ETPmark3_Berechnung();
			break;

	 case 5:
			Haeufigk_zaehlen(FALSE);
			Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									 Letztes_Zeichen3, Letztes_Zeichen4);

			break;

	 case 6:
			Haeufigk_zaehlen(FALSE);
			Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									 Letztes_Zeichen3, Letztes_Zeichen4);
			ETPmark2_Berechnung();
			break;

	 case 7:
			Haeufigk_zaehlen(FALSE);
			Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									 Letztes_Zeichen3, Letztes_Zeichen4);
			ETPmark3_Berechnung();
			break;

	 case 8:
			Haeufigk_zaehlen(FALSE);
			Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
									 Letztes_Zeichen3, Letztes_Zeichen4);
			break;

	 default:
			break;
	 }
	HFK.ermittelt1 = TRUE;
	ETP.ermittelt1 = TRUE;
	}//falls neue Parameter -> HFK wird berechnet

		 hdc = BeginPaint (hwnd, &ps);
		 Fenstereigenschaften (hwnd, hdc);
		 HFK_Paint(hdc, rect);
		 EndPaint (hwnd, &ps);

		 return 0;

  case WM_RBUTTONDOWN:
		 HFKOPT(hwnd);
		 return 0;

  case WM_DESTROY:
		 Fenster.HFK = FALSE;
		 FensterDest(hwndClient);
		 if(Fenster.neu != 0)
	OrdnenAbbau(hwndClient);
		 EnableMenuItem(hMenu, IDM_SHFK, MF_GRAYED);
		 EnableMenuItem(hMenu, IDM_OHFK, MF_ENABLED);
		 return 0 ;
  }
 return DefMDIChildProc (hwnd, message, wParam, lParam) ;
}


void HFK_berechnen(void)
 {
 int				i, j;

 for(i=0; i<=2; i++)
  {
  for(j=0; j<=3; j++)
	{
	if(Haeufigkeit1[i]>0)
	 HFK_bedingt[i][j]=100*HFK_verbund[i][j]/Haeufigkeit1[i];
	if(HFK_Buffer[j]>0)
	 HFK_rueck[i][j]=100*HFK_verbund[i][j]/HFK_Buffer[j];
	}
  }

 return;
 }


void HFK_Ausgabe1_5(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 HBRUSH				hBrush;
 int					i;
 void 				sortieren (float v[], int n);
 void					AlphabetInit(void);

//Array initialisieren
 for(i=0; i<=6; i++)
  Array[i]=Haeufigkeit1[i];
 Array[7]=Haeufigkeit1[31];

//Array und Alphabet sortieren
 for(i=0; i<=6; i++)
  {
  sprintf (szBuffer, "%c", 65+i);
  strcpy(Alphabet[i], szBuffer);
  }
 sprintf (szBuffer, "LZ");
 strcpy(Alphabet[7], szBuffer);
 sortieren(Array, 8);

//Ausgabe der Balkendiagramme
  hBrush = SelectObject (hdc, CreateSolidBrush(RGB(0, 0, 255)));
  ybottom=rect.bottom/4+2*tm.tmHeight;
  if(Array[0]!=0.0)
	{
	xpos=rect.right/2-23*tm.tmAveCharWidth;
	for(i=0; i<=7; i++)
	 {
	 //Zeile1
	 Hoehe=Array[i]/Array[0]*(3.5*tm.tmHeight);
	 ytop=ybottom-Hoehe;
	 Rectangle(hdc, xpos, ytop, xpos+4*tm.tmAveCharWidth, ybottom);
	 TextOut (hdc, xpos+2*tm.tmAveCharWidth, ybottom, Alphabet[i], strlen (Alphabet[i]));
	 sprintf (szBuffer, "%.2f", Array[i]);
	 TextOut (hdc, xpos+2*tm.tmAveCharWidth, ytop-tm.tmHeight, szBuffer, strlen (szBuffer));
	 xpos+=tm.tmAveCharWidth*6;
	 }
	}
  DeleteObject (SelectObject (hdc, hBrush));

//Zeile2
 if(codiert)
  {
  xpos=rect.right/2-5*tm.tmAveCharWidth;

  sprintf (szBuffer, "0");
  strcpy(Alphabet[0], szBuffer);
  sprintf (szBuffer, "1");
  strcpy(Alphabet[1], szBuffer);
  sortieren(HFK_Cod1, 2);

  ybottom=rect.bottom*3/4+2*tm.tmHeight;

  hBrush = SelectObject (hdc, CreateSolidBrush(RGB(255, 0, 0)));
  for(i=0; i<=1; i++)
	{
	Hoehe=HFK_Cod1[i]/HFK_Cod1[0]*(3.5*tm.tmHeight);
	ytop=ybottom-Hoehe;
	Rectangle(hdc, xpos, ytop, xpos+4*tm.tmAveCharWidth, ybottom);
	TextOut (hdc, xpos+2*tm.tmAveCharWidth, ybottom, Alphabet[i], strlen (Alphabet[i]));
	sprintf (szBuffer, "%.2f", HFK_Cod1[i]);
	TextOut (hdc, xpos+2*tm.tmAveCharWidth, ytop-tm.tmHeight, szBuffer, strlen (szBuffer));
	xpos+=tm.tmAveCharWidth*6;
	}
  }

//Textausgabe
  SetTextAlign(hdc, TA_RIGHT);
  SetBkColor(hdc, RGB(0, 0, 255));
  SetTextColor(hdc, RGB(255, 255, 255));
  sprintf (szBuffer, " Quellenfolge ");
  TextOut (hdc, rect.right, 0, szBuffer, strlen (szBuffer));
  if(codiert)
	{
	SetBkColor(hdc, RGB(255, 0, 0));
	sprintf (szBuffer, " Codefolge ");
	TextOut (hdc, rect.right, rect.bottom/2, szBuffer, strlen (szBuffer));
	}
  SetTextColor(hdc, RGB(0, 0, 0));

 DeleteObject (SelectObject (hdc, hBrush));

 return;
 }


void HFK_Ausgabe2(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 short				i, j;
 extern void		Arrow(HDC hdc, TEXTMETRIC tm, int x, int y, float a, float b,
							  float c, float d, float e, float f, float g, float h);

 ypos=rect.bottom/2-10*tm.tmHeight;

 for(i=0; i<=2; i++)
  {
  xpos=rect.right/2-20*tm.tmAveCharWidth;
  ypos+=4*tm.tmHeight;
  for(j=0; j<=3; j++)
	{
	Rectangle(hdc, xpos, ypos, xpos+10*tm.tmAveCharWidth, ypos+4*tm.tmHeight);
	sprintf (szBuffer, "%.2f", HFK_verbund[i][j]*100);
	SetBkColor(hdc, RGB(255, 255, 0));
	TextOut (hdc, xpos+5*tm.tmAveCharWidth, ypos+.5*tm.tmHeight, szBuffer, strlen (szBuffer));
	sprintf (szBuffer, "%.2f", HFK_bedingt[i][j]*100);
	SetBkColor(hdc, RGB(0, 255, 0));
	SetTextColor(hdc, RGB(0, 0, 0));
	TextOut (hdc, xpos+5*tm.tmAveCharWidth, ypos+1.5*tm.tmHeight, szBuffer, strlen (szBuffer));
	sprintf (szBuffer, "%.2f", HFK_rueck[i][j]*100);
	SetBkColor(hdc, RGB(255, 0, 255));
	TextOut (hdc, xpos+5*tm.tmAveCharWidth, ypos+2.5*tm.tmHeight, szBuffer, strlen (szBuffer));
	xpos+=10*tm.tmAveCharWidth;
	}
  }

//Textausgabe
  SetBkColor(hdc, RGB(255, 255, 0));
  TextOut(hdc, rect.right/2-20*tm.tmAveCharWidth, rect.bottom/2+6.5*tm.tmHeight,
  " Verbund- ", 10);
  SetBkColor(hdc, RGB(0, 255, 0));
  SetTextColor(hdc, RGB(0, 0, 0));
  TextOut(hdc, rect.right/2-10.5*tm.tmAveCharWidth, rect.bottom/2+6.5*tm.tmHeight,
  " Bedingte- ", 11);
  SetBkColor(hdc, RGB(255, 0, 255));
  TextOut(hdc, rect.right/2+.5*tm.tmAveCharWidth, rect.bottom/2+6.5*tm.tmHeight,
  " Rckschlu- ", 13);
  SetBkColor(hdc, RGB(255, 255, 255));
  TextOut(hdc, rect.right/2+16*tm.tmAveCharWidth, rect.bottom/2+6.5*tm.tmHeight,
  " Wahrscheinlichkeit ", 20);

  SetBkColor(hdc, RGB(255, 255, 255));
  SetTextColor(hdc, RGB(0, 0, 150));
  TextOut(hdc, rect.right/2-22*tm.tmAveCharWidth, rect.bottom/2-4.5*tm.tmHeight, "A", 1);
  TextOut(hdc, rect.right/2-22*tm.tmAveCharWidth, rect.bottom/2-.5*tm.tmHeight, "B", 1);
  TextOut(hdc, rect.right/2-22*tm.tmAveCharWidth, rect.bottom/2+3.5*tm.tmHeight, "C", 1);
  SetTextColor(hdc, RGB(150, 0, 0));
  TextOut(hdc, rect.right/2-15*tm.tmAveCharWidth, rect.bottom/2-7.5*tm.tmHeight, "a", 1);
  TextOut(hdc, rect.right/2-5*tm.tmAveCharWidth, rect.bottom/2-7.5*tm.tmHeight, "b", 1);
  TextOut(hdc, rect.right/2+5*tm.tmAveCharWidth, rect.bottom/2-7.5*tm.tmHeight, "c", 1);
  TextOut(hdc, rect.right/2+15*tm.tmAveCharWidth, rect.bottom/2-7.5*tm.tmHeight, "d", 1);

  MoveTo(hdc, rect.right/2-27*tm.tmAveCharWidth, rect.bottom/2-7.5*tm.tmHeight);
  LineTo(hdc, rect.right/2-20*tm.tmAveCharWidth, rect.bottom/2-7.5*tm.tmHeight);
  MoveTo(hdc, rect.right/2-27*tm.tmAveCharWidth, rect.bottom/2-7.5*tm.tmHeight);
  LineTo(hdc, rect.right/2-27*tm.tmAveCharWidth, rect.bottom/2-4.5*tm.tmHeight);
  Arrow(hdc, tm, rect.right/2-20*tm.tmAveCharWidth, rect.bottom/2-7.5*tm.tmHeight,
																	0, 0, -1, -.3, -.5, 0, -1, .3);
  Arrow(hdc, tm, rect.right/2-27*tm.tmAveCharWidth, rect.bottom/2-4.5*tm.tmHeight,
																	0, 0, -.3, -1, 0, -.5, .3, -1);
  TextOut(hdc, rect.right/2-22*tm.tmAveCharWidth, rect.bottom/2-7*tm.tmHeight, "v", 1);
  SetTextColor(hdc, RGB(0, 0, 150));
  TextOut(hdc, rect.right/2-25*tm.tmAveCharWidth, rect.bottom/2-6*tm.tmHeight, "q", 1);
  SetTextColor(hdc, RGB(0, 0, 0));

 return;
 }


void HFK_Ausgabe3_6(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 HBRUSH				hBrush;
 int					i;
 float				hArray[2][2];
 float				MaxHaeuf;
 char					a[2][2][4];
 void 				sortieren (float v[], int n);
 void					AlphabetInit(void);

//Array und Alphabet sortieren
  strcpy(Alphabet[0], "A");
  strcpy(Alphabet[1], "B");
  for(i=0; i<=1; i++)
	Array[i]=Haeufigkeit1[i];
  sortieren(Array, 2);

  xpos=rect.right/2-11*tm.tmAveCharWidth;
  ybottom=rect.bottom/4+2*tm.tmHeight;

  hBrush = SelectObject (hdc, CreateSolidBrush(RGB(0, 0, 255)));
  for(i=0; i<=1; i++)
	{
	Hoehe=Array[i]/Array[0]*(3.5*tm.tmHeight);
	ytop=ybottom-Hoehe;
	Rectangle(hdc, xpos, ytop, xpos+10*tm.tmAveCharWidth, ybottom);
	TextOut (hdc, xpos+5*tm.tmAveCharWidth, ybottom, Alphabet[i], strlen (Alphabet[i]));
	sprintf (szBuffer, "%.2f", Array[i]);
	TextOut (hdc, xpos+5*tm.tmAveCharWidth, ytop-tm.tmHeight, szBuffer, strlen (szBuffer));
	xpos+=tm.tmAveCharWidth*12;
	}
  DeleteObject (SelectObject (hdc, hBrush));

  for(i=0; i<=1; i++)//Reihenfolge Haeufigkeit1 speichern
	szBuffer[i]=Alphabet[i][0];

  sprintf(Alphabet[0], "A|A");
  sprintf(Alphabet[1], "B|A");

  for(i=0; i<=1; i++)
	hArray[0][i]=HFK_bedingt[0][i];
  sortieren(hArray[0], 2);
  for(i=0; i<=1; i++)
	strcpy(a[0][i], Alphabet[i]);

  sprintf(Alphabet[0], "A|B");
  sprintf(Alphabet[1], "B|B");

  for(i=0; i<=1; i++)
	hArray[1][i]=HFK_bedingt[1][i];
  sortieren(hArray[1], 2);
  for(i=0; i<=1; i++)
	strcpy(a[1][i], Alphabet[i]);

  memset(Array, 0, 140);
  for(i=0; i<=1; i++)
	{
	Array[i]=hArray[szBuffer[0]-65][i];
	strcpy(Alphabet[i], a[szBuffer[0]-65][i]);
	}
  for(i=0; i<=1; i++)
	{
	Array[i+2]=hArray[szBuffer[1]-65][i];
	strcpy(Alphabet[i+2], a[szBuffer[1]-65][i]);
	}

  xpos=rect.right/2-11*tm.tmAveCharWidth;
  ybottom+=8*tm.tmHeight;

  MaxHaeuf=Array[0];
  for(i=1; i<=33; i++)
	{
	if(Array[i]>MaxHaeuf)
	 MaxHaeuf=Array[i];
	}
  hBrush = SelectObject (hdc, CreateSolidBrush(RGB(255, 0, 0)));
  for(i=0; i<=3; i++)
	{
	Hoehe=Array[i]/MaxHaeuf*(3.5*tm.tmHeight);
	ytop=ybottom-Hoehe;
	Rectangle(hdc, xpos, ytop, xpos+4*tm.tmAveCharWidth, ybottom);
	TextOut (hdc, xpos+2*tm.tmAveCharWidth, ybottom, Alphabet[i], strlen (Alphabet[i]));
	sprintf (szBuffer, "%.2f", 100*Array[i]);
	TextOut (hdc, xpos+2*tm.tmAveCharWidth, ytop-tm.tmHeight, szBuffer, strlen (szBuffer));
	xpos+=tm.tmAveCharWidth*6;
	}
  DeleteObject (SelectObject (hdc, hBrush));

  SetTextAlign(hdc, TA_RIGHT);
  SetBkColor(hdc, RGB(0, 0, 255));
  SetTextColor(hdc, RGB(255, 255, 255));
  TextOut (hdc, rect.right, 0, " absolute Hufigkeiten ", 23);
  SetBkColor(hdc, RGB(255, 0, 0));
  TextOut (hdc, rect.right, 8*tm.tmHeight, " bedingte Hufigkeiten ", 22);
  SetTextColor(hdc, RGB(0, 0, 0));

 return;
 }


void HFK_Ausgabe4_7(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 HBRUSH				hBrush;
 short				i;
 float				hArray[3][3];
 float				MaxHaeuf;
 char					a[3][3][4];
 void 				sortieren (float v[], int n);
 void					AlphabetInit(void);

//Array und Alphabet sortieren
  strcpy(Alphabet[0], "A");
  strcpy(Alphabet[1], "B");
  strcpy(Alphabet[2], "C");
  for(i=0; i<=2; i++)
	Array[i]=Haeufigkeit1[i];
  sortieren(Array, 3);

  hBrush = SelectObject (hdc, CreateSolidBrush(RGB(0, 0, 255)));
  xpos=rect.right/2-25*tm.tmAveCharWidth;
  ybottom=rect.bottom/4+2*tm.tmHeight;

  for(i=0; i<=2; i++)
	{
	Hoehe=Array[i]/Array[0]*(3.5*tm.tmHeight);
	ytop=ybottom-Hoehe;
	Rectangle(hdc, xpos, ytop, xpos+16*tm.tmAveCharWidth, ybottom);
	TextOut (hdc, xpos+8*tm.tmAveCharWidth, ybottom, Alphabet[i], strlen (Alphabet[i]));
	sprintf (szBuffer, "%.2f", Array[i]);
	TextOut (hdc, xpos+8*tm.tmAveCharWidth, ytop-tm.tmHeight, szBuffer, strlen (szBuffer));
	xpos+=tm.tmAveCharWidth*18;
	}
  DeleteObject (SelectObject (hdc, hBrush));

  for(i=0; i<=2; i++)//Reihenfolge Haeufigkeit1 speichern
	szBuffer[i]=Alphabet[i][0];

  sprintf(Alphabet[0], "A|A");
  sprintf(Alphabet[1], "B|A");
  sprintf(Alphabet[2], "C|A");

  for(i=0; i<=2; i++)
	hArray[0][i]=HFK_bedingt[0][i];
  sortieren(hArray[0], 3);
  for(i=0; i<=2; i++)
	strcpy(a[0][i], Alphabet[i]);

  sprintf(Alphabet[0], "A|B");
  sprintf(Alphabet[1], "B|B");
  sprintf(Alphabet[2], "C|B");

  for(i=0; i<=2; i++)
	hArray[1][i]=HFK_bedingt[1][i];
  sortieren(hArray[1], 3);
  for(i=0; i<=2; i++)
	strcpy(a[1][i], Alphabet[i]);

  sprintf(Alphabet[0], "A|C");
  sprintf(Alphabet[1], "B|C");
  sprintf(Alphabet[2], "C|C");

  for(i=0; i<=2; i++)
	hArray[2][i]=HFK_bedingt[2][i];
  sortieren(hArray[2], 3);
  for(i=0; i<=2; i++)
	strcpy(a[2][i], Alphabet[i]);

  memset(Array, 0, 140);
  for(i=0; i<=2; i++)
	{
	Array[i]=hArray[szBuffer[0]-65][i];
	strcpy(Alphabet[i], a[szBuffer[0]-65][i]);
	}
  for(i=0; i<=2; i++)
	{
	Array[i+3]=hArray[szBuffer[1]-65][i];
	strcpy(Alphabet[i+3], a[szBuffer[1]-65][i]);
	}
  for(i=0; i<=2; i++)
	{
	Array[i+6]=hArray[szBuffer[2]-65][i];
	strcpy(Alphabet[i+6], a[szBuffer[2]-65][i]);
	}

  xpos=rect.right/2-25*tm.tmAveCharWidth;
  ybottom+=8*tm.tmHeight;

  MaxHaeuf=Array[0];
  for(i=1; i<=33; i++)
	{
	if(Array[i]>MaxHaeuf)
	 MaxHaeuf=Array[i];
	}
  hBrush = SelectObject (hdc, CreateSolidBrush(RGB(255, 0, 0)));
  for(i=0; i<=8; i++)
	{
	Hoehe=Array[i]/MaxHaeuf*(3.5*tm.tmHeight);
	ytop=ybottom-Hoehe;
	Rectangle(hdc, xpos, ytop, xpos+4*tm.tmAveCharWidth, ybottom);
	TextOut (hdc, xpos+2*tm.tmAveCharWidth, ybottom, Alphabet[i], strlen (Alphabet[i]));
	sprintf (szBuffer, "%.2f", 100*Array[i]);
	TextOut (hdc, xpos+2*tm.tmAveCharWidth, ytop-tm.tmHeight, szBuffer, strlen (szBuffer));
	xpos+=tm.tmAveCharWidth*6;
	}

 DeleteObject (SelectObject (hdc, hBrush));

  SetTextAlign(hdc, TA_RIGHT);
  SetBkColor(hdc, RGB(0, 0, 255));
  SetTextColor(hdc, RGB(255, 255, 255));
  TextOut (hdc, rect.right, 0, " absolute Hufigkeiten ", 23);
  SetBkColor(hdc, RGB(255, 0, 0));
  TextOut (hdc, rect.right, 8*tm.tmHeight, " bedingte Hufigkeiten ", 22);
  SetTextColor(hdc, RGB(0, 0, 0));

 return;
 }


void HFK_Ausgabe8(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 short		a, b, c;
 short		Auswahl(short s);
 void			AlphabetInit(void);
 void			AusgabeBalken8(HDC hdc, TEXTMETRIC tm, short s, short k, short j);

//Alphabet initialisieren
  AlphabetInit();

//Ausgabe der Auftrittshufigkeiten
//Linien zeichnen
  MoveTo(hdc, 0, tm.tmHeight*11);
  LineTo(hdc, rect.right, tm.tmHeight*11);
  MoveTo(hdc, 0, tm.tmHeight*22.5);
  LineTo(hdc, rect.right, tm.tmHeight*22.5);

//Ermitteln der ausgewhlten Codes
  a=Auswahl(0);
  b=Auswahl(1);
  c=Auswahl(2);
//Spalte1
  ybottom=4.5*tm.tmHeight;
  AusgabeBalken8(hdc, tm, 1, 0, 0);

//Spalte2
  ybottom=16*tm.tmHeight;
 AusgabeBalken8(hdc, tm, 2, a, 0);


//Spalte3
  ybottom=27.5*tm.tmHeight;
  AusgabeBalken8(hdc, tm, 3, b, c);


//Textausgabe
  SetTextAlign(hdc, TA_RIGHT);
  sprintf (szBuffer, " absolute Hufigkeiten ");
// Armin Erben  SetBkColor(hdc, RGB(0, 0, 255));
// Armin Erben SetTextColor(hdc, RGB(255, 255, 255));
  SetBkColor(hdc, RGB(0, 255, 0));
  SetTextColor(hdc, RGB(0, 0, 0));
  TextOut (hdc, rect.right, 0, szBuffer, strlen (szBuffer));
  SetTextColor(hdc, RGB(255, 255, 255));
  if(VorNach2)
	sprintf (szBuffer, " nach '");
  else
	sprintf (szBuffer, " vor '");
  strcat(szBuffer, Zeich[0]);
  strcat(szBuffer, "' ");
// Armin Erben  SetBkColor(hdc, RGB(0, 255, 0));
  SetBkColor(hdc, RGB(255, 0, 0));
	 TextOut (hdc, rect.right, 11.5*tm.tmHeight, szBuffer, strlen (szBuffer));
  if(VorNach3)
	sprintf (szBuffer, " nach '");
  else
	sprintf (szBuffer, " vor '");
  strcat(szBuffer, Zeich[1]);
  strcat(szBuffer, Zeich[2]);
  strcat(szBuffer, "' ");
// Armin Erben SetBkColor(hdc, RGB(255, 0, 0));
// Armin Erben SetTextColor(hdc, RGB(255, 255, 255));
	SetBkColor(hdc, RGB(255, 255, 0));
  SetTextColor(hdc, RGB(0, 0, 0));
	TextOut (hdc, rect.right, 23*tm.tmHeight, szBuffer, strlen (szBuffer));
  SetTextColor(hdc, RGB(0, 0, 0));
 return;
 }


void AusgabeBalken8(HDC hdc, TEXTMETRIC tm, short s, short k, short j)
 {
 HBRUSH	hBrush;
 int		i;
 float	MaxHaeuf;
 long		Anzahl_2=0;
 long		Anzahl_3=0;
 void 	sortieren (float v[], int n);
 void		AlphabetInit(void);

//Array initialisieren
	  switch(s)
	{
	case 1:
		  for(i=0; i<=33; i++)
			Array[i]=Haeufigkeit1[i];
// Armin Erben 10.12.1995	  hBrush = SelectObject (hdc, CreateSolidBrush(RGB(0, 0, 255)));
		  hBrush = SelectObject (hdc, CreateSolidBrush(RGB(0, 255, 0)));

		  break;

	case 2:
		  if(VorNach2)
			{
			for(i=0; i<=33; i++)
			 Anzahl_2+=Haeufigkeit2[k][i];
			for(i=0; i<=33; i++)
			 {
			 if(Anzahl_2>0)
			  Array[i]=100*(float)(Haeufigkeit2[k][i])/(float)(Anzahl_2);
			 else
			  Array[i]=0;
			 }
			}
		  else
			{
			for(i=0; i<=33; i++)
			 Anzahl_2+=Haeufigkeit2[i][k];
			for(i=0; i<=33; i++)
			 {
			 if(Anzahl_2>0)
			  Array[i]=100*(float)(Haeufigkeit2[i][k])/(float)(Anzahl_2);
			 else
			  Array[i]=0;
			 }
			}
// Armin Erben 10.12.1995  hBrush = SelectObject (hdc, CreateSolidBrush(RGB(0, 255, 0)));
		  hBrush = SelectObject (hdc, CreateSolidBrush(RGB(255, 0, 0)));
		  break;

	case 3:
		  if(VorNach3)
			{
			for(i=0; i<=33; i++)
			 Anzahl_3+=Haeufigkeit3[k][j][i];
			for(i=0; i<=33; i++)
			 {
			 if(Anzahl_3>0)
			  Array[i]=100*(float)(Haeufigkeit3[k][j][i])/(float)(Anzahl_3);
			 else
			  Array[i]=0;
			 }
			}
		  else
			{
			for(i=0; i<=33; i++)
			 Anzahl_3+=Haeufigkeit3[i][k][j];
			for(i=0; i<=33; i++)
			 {
			 if(Anzahl_3>0)
			  Array[i]=100*(float)(Haeufigkeit3[i][k][j])/(float)(Anzahl_3);
			 else
			  Array[i]=0;
			 }
			}
// Armin Erben 10.12.1995  hBrush = SelectObject (hdc, CreateSolidBrush(RGB(255, 0, 0)));
		  hBrush = SelectObject (hdc, CreateSolidBrush(RGB(255, 255, 0)));
		  break;
	}

//Maximum der Auftrittshufigkeiten feststellen
  MaxHaeuf=Array[0];
  for(i=1; i<=33; i++)
	{
	if(Array[i]>MaxHaeuf)
	 MaxHaeuf=Array[i];
	}
//Array und Alphabet sortieren
	AlphabetInit();
	sortieren(Array, 34);

//Ausgabe der Balkendiagramme
  if(MaxHaeuf!=0.0)
	{
	xpos=4*tm.tmAveCharWidth;
	for(i=0; i<=17; i++)
	 {
	 //Zeile1
	 Hoehe=Array[i]/MaxHaeuf*(3.5*tm.tmHeight);
	 ytop=ybottom-Hoehe;
	 Rectangle(hdc, xpos, ytop, xpos+4*tm.tmAveCharWidth, ybottom);
	 TextOut (hdc, xpos+2*tm.tmAveCharWidth, ybottom, Alphabet[i], strlen (Alphabet[i]));
	 sprintf (szBuffer, "%.2f", Array[i]);
	 TextOut (hdc, xpos+2*tm.tmAveCharWidth, ytop-tm.tmHeight, szBuffer, strlen (szBuffer));
	 xpos+=tm.tmAveCharWidth*6;
	 }

	//Zeile2
	xpos=4*tm.tmAveCharWidth;
	ybottom+=5.5*tm.tmHeight;
	for(i=18; i<=33; i++)
	 {
	 Hoehe=Array[i]/MaxHaeuf*(3.5*tm.tmHeight);
	 ytop=ybottom-Hoehe;
	 Rectangle(hdc, xpos, ytop, xpos+4*tm.tmAveCharWidth, ybottom);
	 TextOut (hdc, xpos+2*tm.tmAveCharWidth, ybottom, Alphabet[i], strlen (Alphabet[i]));
	 sprintf (szBuffer, "%.2f", Array[i]);
	 TextOut (hdc, xpos+2*tm.tmAveCharWidth, ytop-tm.tmHeight, szBuffer, strlen (szBuffer));
	 if(i==30 || i==31)
	  xpos+=tm.tmAveCharWidth*7;
	 else if(i==32 || i==33)
	  xpos+=tm.tmAveCharWidth*8;
	 else
	  xpos+=tm.tmAveCharWidth*6;
	 }
	}
  DeleteObject (SelectObject (hdc, hBrush));

 return;
 }


void HFK_Paint(HDC hdc, RECT rect)
 {
 TEXTMETRIC				tm;
 void						HFK_Ausgabe1_5(HDC hdc, RECT rect, TEXTMETRIC tm);
 void						HFK_Ausgabe2(HDC hdc, RECT rect, TEXTMETRIC tm);
 void						HFK_Ausgabe3_6(HDC hdc, RECT rect, TEXTMETRIC tm);
 void						HFK_Ausgabe4_7(HDC hdc, RECT rect, TEXTMETRIC tm);
 void						HFK_Ausgabe8(HDC hdc, RECT rect, TEXTMETRIC tm);


 SetMapMode (hdc, MM_TEXT);
 SetTextAlign(hdc, TA_CENTER);
 SetViewportOrg(hdc, 0, 0);
 GetTextMetrics(hdc,&tm);

 switch(Modell)
  {
  case 1:
		 HFK_Ausgabe1_5(hdc, rect, tm);

		 break;

  case 2:
		 HFK_Ausgabe2(hdc, rect, tm);

		 break;

  case 3:
		 HFK_Ausgabe3_6(hdc, rect, tm);

		 break;

  case 4:
		 HFK_Ausgabe4_7(hdc, rect, tm);

		 break;

  case 5:
		 HFK_Ausgabe1_5(hdc, rect, tm);

		 break;

  case 6:
		 HFK_Ausgabe3_6(hdc, rect, tm);

		 break;

  case 7:
		 HFK_Ausgabe4_7(hdc, rect, tm);

		 break;

  case 8:
		 HFK_Ausgabe8(hdc, rect, tm);

		 break;

  }

return;
}

short Auswahl(short s)
 {
 short			Code;

 for(Code=0; Code<=33; Code++)
  {
  if(!strcmp(Zeich[s],Alphabet[Code]))
	break;
  }

 return Code;
 }


void sortieren (float v[], int n)
 {
 int		gap, i, j;
 float	temp1;
 char		temp2[11];

 for(gap=n/2; gap>0; gap/=2)
  {
  for(i=gap; i<n; i++)
	{
	for(j=i-gap; j>=0 && v[j]<v[j+gap]; j-=gap)
	 {
	 temp1=v[j];
	 strcpy(temp2, Alphabet[j]);
	 v[j]=v[j+gap];
	 strcpy(Alphabet[j], Alphabet[j+gap]);
	 v[j+gap]=temp1;
	 strcpy(Alphabet[j+gap], temp2);
	 }
	}
  }
 return;
 }


void AlphabetInit(void)
 {
 int		i;

 for(i=0; i<=25; i++)
  {
  sprintf(szBuffer, "%c", i+97);
  strcpy(Alphabet[i], szBuffer);
  }
  sprintf (szBuffer, "%c", 228);
  strcpy(Alphabet[26], szBuffer);
  sprintf (szBuffer, "%c", 246);
  strcpy(Alphabet[27], szBuffer);
  sprintf (szBuffer, "%c", 252);
  strcpy(Alphabet[28], szBuffer);
  sprintf (szBuffer, "%c", 223);
  strcpy(Alphabet[29], szBuffer);
  sprintf (szBuffer, "ZI");
  strcpy(Alphabet[30], szBuffer);
  sprintf (szBuffer, "LZ");
  strcpy(Alphabet[31], szBuffer);
  sprintf (szBuffer, "IP");
  strcpy(Alphabet[32], szBuffer);
  sprintf (szBuffer, "SZ");
  strcpy(Alphabet[33], szBuffer);
  sprintf (szBuffer, "");
  strcpy(Alphabet[34], szBuffer);

 return;
 }


void Haeufigk_zaehlen(BOOL m)
{
 long          lLaenge;
 long          lPosition=0;
 unsigned      y=0;
 int           hFile1;
 unsigned 		Ende;
 char				Code[2];
 short 			Zeichen1,Zeichen2,Zeichen3,Zeichen4,Zeichen5;
 unsigned		i, j, k, n, o;
 char          szFile[_MAX_PATH];
 void 			Haeufigk_schreiben(int Zeichen1, int Zeichen2,
											 int Zeichen3, int Zeichen4, int Zeichen5);


 SetCursor(hCurWait);

 strcpy(szFile,Datei1.szFileName);
 hFile1 = _lopen((LPSTR)szFile, OF_READ|OF_SHARE_DENY_WRITE);
 if(Modell>4)
  {
  lLength=filelength(hFile1);
  }

//INITIALISIERUNG
 Code[1]='\0';
 for (i=0; i<=35; i++)
  Haeufigkeit1[i]=0.0;

 for (i=0; i<=34; i++)
  {
  for (j=0; j<=34; j++)
	{
	Haeufigkeit2[i][j]=0;
	for (k=0; k<=34; k++)
	 Haeufigkeit3[i][j][k]=0;
	}
  }
 for(i=0; i<=2; i++)
  {
  for(j=0; j<=2; j++)
	{
	for(k=0; k<=2; k++)
	 {
	 for(n=0; n<=2; n++)
	  {
	  Haeufigkeit4[i][j][k][n]=0;
	  for(o=0; o<=2; o++)
		Haeufigkeit5[i][j][k][n][o]=0;
	  }
	 }
	}
  }


if(Modell==1 || Modell==2 || Modell==5 || Modell==8)
 {
 lLaenge=lLength;


while(lLaenge>0)
 {
 if(lLaenge<65535L)
  {
  hBuffer = GlobalAlloc (GHND, lLaenge);
  lpstrBuffer=GlobalLock(hBuffer);

  if(Modell==5 || Modell==8)//Dateien
	{
	_llseek(hFile1, lPosition, 0);
	_lread (hFile1, lpstrBuffer, (WORD) lLaenge);
	}
  if(Modell==1 || Modell==2)//Im Speicher erzeugte Quellen
	{
	if(!m)//1. statistisch unabhngige Quelle
	 {
	 for(i=0; i<=(lLaenge-1); i++)
	  *(lpstrBuffer+i)=*(lpstrPar+i);
	 }
	else//2. statistisch unabhngige Quelle
	 {
	 for(i=0; i<=(lLaenge-1); i++)
	  *(lpstrBuffer+i)=*(lpstrPar2+i);
	 }
	}
  Ende=(int)lLaenge;
  lLaenge=0;
  y=0;
  }

 else
  {
  hBuffer = GlobalAlloc (GHND, 65535L);
  lpstrBuffer=GlobalLock(hBuffer);
  _llseek(hFile1, lPosition, 0);
  _lread (hFile1, lpstrBuffer, 65535U);
  lPosition+=65535L;
  lLaenge-=65535L;
  Ende=(int)65535L;
  y=0;
  }

 while (y <= (Ende-1))
  {
  Code[0] = *(lpstrBuffer+y);

  if (y==0)
	{
	Zeichen5=34;
	Zeichen4=34;
	Zeichen3=34;
	Zeichen2=34;
	Zeichen1=34;
	}
	if(y>1)
	 Zeichen1=Zeichen2;

	Zeichen2=Zeichen3;


//Kleinbuchstaben
  if ((int)Code[0]>=97 && (int)Code[0]<=122)
	 {
	 Zeichen3=(int)Code[0]-97;
	 Haeufigk_schreiben(Zeichen1, Zeichen2, Zeichen3, Zeichen4, Zeichen5);
	 }

//Leerzeichen
  else if ((int)Code[0]==32)
	 {
	 if(OhneLZ)
	  Zeichen2=Zeichen1;//Zwischenspeicherung
	 else
	  {
	  Zeichen3=31;
	  Haeufigk_schreiben(Zeichen1, Zeichen2, Zeichen3, Zeichen4, Zeichen5);
	  }
	 }

//Grobuchstaben
  else if ((int)Code[0]>=65 && (int)Code[0]<=90)
	 {
	 Zeichen3=(int)Code[0]-65;
	 Haeufigk_schreiben(Zeichen1, Zeichen2, Zeichen3, Zeichen4, Zeichen5);
	 }

//Umlaut 
  else if ((int)Code[0]==-124 || (int)Code[0]==-114)
	 {
	 Zeichen3=26;
	 Haeufigk_schreiben(Zeichen1, Zeichen2, Zeichen3, Zeichen4, Zeichen5);
	 }

//Umlaut 
  else if ((int)Code[0]==-108 || (int)Code[0]==-103)
	 {
	 Zeichen3=27;
	 Haeufigk_schreiben(Zeichen1, Zeichen2, Zeichen3, Zeichen4, Zeichen5);
	 }

//Umlaut 
  else if ((int)Code[0]==-127 || (int)Code[0]==-102)
	 {
	 Zeichen3=28;
	 Haeufigk_schreiben(Zeichen1, Zeichen2, Zeichen3, Zeichen4, Zeichen5);
	 }

//Scharfes 
  else if ((int)Code[0]==-31)
	 {
	 Zeichen3=29;
	 Haeufigk_schreiben(Zeichen1, Zeichen2, Zeichen3, Zeichen4, Zeichen5);
	 }

//Ziffern
  else if ((int)Code[0]>=48 && (int)Code[0]<=57)
	 {
	 if(OhneZI)
	  Zeichen2=Zeichen1;//Zwischenspeicherung
	 else
	  {
	  Zeichen3=30;
	  Haeufigk_schreiben(Zeichen1, Zeichen2, Zeichen3, Zeichen4, Zeichen5);
	  }
	 }

//Interpunktion
	else if ((int)Code[0]==33 || (int)Code[0]==44 || (int)Code[0]==45 || (int)Code[0]==46 ||
				(int)Code[0]==58 || (int)Code[0]==59 || (int)Code[0]==63)
	 {
	 if(OhneIP)
	  Zeichen2=Zeichen1;//Zwischenspeicherung
	 else
	  {
	  Zeichen3=32;
	  Haeufigk_schreiben(Zeichen1, Zeichen2, Zeichen3, Zeichen4, Zeichen5);
	  }
	 }

//Sonderzeichen
  else if (((int)Code[0]>=34 && (int)Code[0]<=43) || (int)Code[0]==47 || ((int)Code[0]>=60 && (int)Code[0]<=62) ||
				(int)Code[0]==64 || ((int)Code[0]>=91 && (int)Code[0]<=95) || ((int)Code[0]>=123 && (int)Code[0]<=126))
	 {
	 if(OhneSZ)
	  Zeichen2=Zeichen1;//Zwischenspeicherung
	 else
	  {
	  Zeichen3=33;
	  Haeufigk_schreiben(Zeichen1, Zeichen2, Zeichen3, Zeichen4, Zeichen5);
	  }
	 }

//Zhlen des Zeilenvorschub unterdrcken
  else if ((int)Code[0]==10 || (int)Code[0]==13)
	 {
	 }

//Rest
  else
	 {
	 Haeufigkeit1[34]++;
	 }
  y++;
  }
 }
 Letztes_Zeichen2=Zeichen2;
 Letztes_Zeichen1=Zeichen3;

 Ausgewertet=0;
 for(i=0; i<=34; i++)
  Ausgewertet+=(long)Haeufigkeit1[i];

 }

 else//wenn Markov-Datei
  {

  hBuffer = GlobalAlloc (GHND, lLength);
  lpstrBuffer=GlobalLock(hBuffer);

  if(Modell==6 || Modell==7)//Dateien
	{
	_llseek(hFile1, lPosition, 0);
	_lread (hFile1, lpstrBuffer, (WORD) lLength);
	}
  if(Modell==3 || Modell==4)
	{
	for(i=0; i<=(lLength-1); i++)
	 *(lpstrBuffer+i)=*(lpstrPar+i);
	}

  while (y <= lLength-1)
	{
	Code[0] = *(lpstrBuffer+y);
	if (y==0)
	 {
	 Zeichen5=3;
	 Zeichen3=3;
	 Zeichen2=3;
	 Zeichen1=3;
	 }
	if(y>3)
	 Zeichen1=Zeichen2;
	if(y>2)
	 Zeichen2=Zeichen3;
	if(y>1)
	 Zeichen3=Zeichen4;
	Zeichen4=Zeichen5;

//Grobuchstaben
	if ((int)Code[0]>=65 && (int)Code[0]<=90)
	 {
	 Zeichen5=(int)Code[0]-65;
	 Haeufigk_schreiben(Zeichen1, Zeichen2, Zeichen3, Zeichen4, Zeichen5);
	 }
	y++;
	}
  Letztes_Zeichen1=Zeichen5;
  Letztes_Zeichen2=Zeichen4;
  Letztes_Zeichen3=Zeichen3;
  Letztes_Zeichen4=Zeichen2;

  }

 _lclose(hFile1);

 GlobalUnlock(hBuffer);
 GlobalFree(hBuffer);
 SetCursor(hCurArrow);

 return;
}

void Haeufigk_schreiben(int Zeichen1, int Zeichen2,
								int Zeichen3, int Zeichen4, int Zeichen5)
 {

 if(Modell==3 || Modell==4 || Modell==6 || Modell==7)
  {
  Haeufigkeit1[Zeichen5]++;
  Haeufigkeit2[Zeichen4][Zeichen5]++;
  Haeufigkeit3[Zeichen3][Zeichen4][Zeichen5]++;
  Haeufigkeit4[Zeichen2][Zeichen3][Zeichen4][Zeichen5]++;
  Haeufigkeit5[Zeichen1][Zeichen2][Zeichen3][Zeichen4][Zeichen5]++;
  }
 else
  {
  Haeufigkeit1[Zeichen3]++;
  Haeufigkeit2[Zeichen2][Zeichen3]++;
  Haeufigkeit3[Zeichen1][Zeichen2][Zeichen3]++;
  }
 return;
 }



