//------------------------------------------------------------------------
//-------------------------------- WDIT.H --------------------------------
//------------------------------------------------------------------------
//----------------- Header-Datei "Wertdiskrete Informationstheorie"-------



#define WDIT_ICON     10
#define SF_ICON       11
#define HFK_ICON      12
#define ETP_ICON      13
#define PAR_ICON      14
#define SH_ICON       15

#define IDSTR_NAME   100
#define IDSTR_TITEL  101

#define ID_ANLEITUNG 106

#define IDM_STATIST_ERZ	110
#define IDM_MARKOV2_ERZ	111
#define IDM_MARKOV3_ERZ	112
#define IDM_TEXT_ERZ	113

#define IDM_KONVERT  114
#define IDM_DOS      115
#define IDM_EXIT     116

#define IDM_STATIST1	120
#define IDM_STATIST2	121
#define IDM_MARKOV2	122
#define IDM_MARKOV3	123
#define IDM_STATIST_DAT	124
#define IDM_MARKOV2_DAT	125
#define IDM_MARKOV3_DAT	126
#define IDM_ASCII			127

#define IDM_HUFFCOD	128
#define IDM_HUFFDEC	129
#define IDM_UEBFEHLER	130

#define IDM_SFOPT		135
#define IDM_HFKOPT   136
#define IDM_ETPOPT	137
#define IDM_HAEUFIG	138

#define IDM_RUN      140
#define IDM_OALLE    141
#define IDM_OSFOLGE	142
#define IDM_OHFK     143
#define IDM_OETP     144
#define IDM_OPARAM   145

#define IDM_SALLE    150
#define IDM_SSFOLGE	151
#define IDM_SHFK     152
#define IDM_SETP     153
#define IDM_SPARAM   154

#define IDM_CASCADE  160
#define IDM_TILE     161
#define IDM_ARRANGE  162
#define IDM_THEORIE  163
#define IDM_VORBER   164
#define IDM_DURCHF   165
#define IDM_LNT      166
#define IDM_AUTOR    167
#define IDM_SOFTWARE 168
#define IDM_HELP     169
#define IDM_ABOUT		170

#define IDD_PAINT    303

#define IDD_pGB      309
#define IDD_pBG      310
#define IDD_FWK_G    311
#define IDD_FWK_B    312
#define IDD_FWK_M    313

#define IDD_2_SYMBOL_UEWK	324

#define IDM_FIRST    325

//Statistisch unabhngige Symbole-Datei
#define IDD_Pa			332
#define IDD_Pb			333
#define IDD_Pc			334
#define IDD_Pd			335
#define IDD_Pe			336
#define IDD_Pf			337
#define IDD_Pg			338
#define IDD_Plz		339
#define IDD_P_LZ		340
#define IDD_ENTRP		341
#define IDD_GROES_SUN	342

//Huffman-Codierung
#define IDD_CODEa	343
#define IDD_CODEb	344
#define IDD_CODEc	345
#define IDD_CODEd	346
#define IDD_CODEe	347
#define IDD_CODEf	348
#define IDD_CODEg	349
#define IDD_CODElz	350

#define IDD_HUFFCOD1	354
#define IDD_HUFFCOD2	355
#define IDD_HUFFCOD3	356
#define IDD_HUFFCOD4	357

//Huffman-Decodierung
#define IDD_DECODEa	358
#define IDD_DECODEb	359
#define IDD_DECODEc	360
#define IDD_DECODEd	361
#define IDD_DECODEe	362
#define IDD_DECODEf	363
#define IDD_DECODEg	364
#define IDD_DECODElz	365

#define IDD_HUFFDEC1	370
#define IDD_HUFFDEC2	371


//Markov
#define IDD_pAA		372
#define IDD_pBB		373
#define IDD_UEB_P3	374
#define IDD_KONST		375
#define IDD_GROES_M2	376
#define IDD_GROES_M3	377

//Text
#define IDD_START	378
#define IDD_GROES_TEXT	379

//Optionen
//Symbolfolge
#define IDD_Z1			380
#define IDD_Z2			381
#define IDD_Z3			382
#define IDD_Z4       383
#define IDD_Z5			384
#define IDD_Z6			385
#define IDD_Z7       386
#define IDD_Z8			387
#define IDD_Z9			388
#define IDD_Z10		389
#define IDD_Z11		390
#define IDD_Z12		391
#define IDD_Z13		392
#define IDD_Z14		393
#define IDD_Z15		394
#define IDD_Z16		395
#define IDD_Z17		396
#define IDD_Z18		397
#define IDD_Z19		398
#define IDD_Z20		399
#define IDD_Z21		400
#define IDD_Z22		401
#define IDD_Z23		402
#define IDD_Z24		403
#define IDD_Z25		404
#define IDD_Z26		405
#define IDD_Z27		406
#define IDD_Z28		407
#define IDD_Z29		408
#define IDD_Z30		409
#define IDD_Z31		410
#define IDD_Z33		412
#define IDD_Z34		413
#define IDD_AUSBLSTELLE	414

//Auftrittshufigkeiten
#define IDD_PVOR2		415
#define IDD_PNACH2	416
#define IDD_PVOR3		417
#define IDD_PNACH3	418
#define IDD_ZEICH		419
#define IDD_ZEICH1	420
#define IDD_ZEICH2	421
#define IDD_ZEICHEN	422
#define IDD_ZIFFER	423
#define IDD_LEERZ		424
#define IDD_INTERP	425
#define IDD_SONDERZ	426
#define IDD_ZEICHEN1	427
#define IDD_ZIFFER1	428
#define IDD_LEERZ1	429
#define IDD_INTERP1	430
#define IDD_SONDERZ1	431
#define IDD_ZEICHEN2	432
#define IDD_ZIFFER2	433
#define IDD_LEERZ2	434
#define IDD_INTERP2	435
#define IDD_SONDERZ2	436

//2 statistisch abhngige Symbolquellen
#define IDD_PA2		440
#define IDD_PB2		441
#define IDD_PC2		442
#define IDD_PAA		443
#define IDD_PAB		444
#define IDD_PAC		445
#define IDD_PAD		446
#define IDD_PBA		447
#define IDD_PBB		448
#define IDD_PBC		449
#define IDD_PBD		450
#define IDD_PCA		451
#define IDD_PCB		452
#define IDD_PCC		453
#define IDD_PCD		454
#define IDD_GROES_ABH	455

//Optionen Entropie
#define IDD_PAFEST	460
#define IDD_PBFEST	461
#define IDD_OHNEZI	462
#define IDD_OHNELZ	463
#define IDD_OHNEIP	464
#define IDD_OHNESZ	465
#define IDD_K1			466
#define IDD_K2			467
#define IDD_K3			468
#define IDD_K4			469
#define IDD_ETP_MK3p	470
#define IDD_ETP_MK3k	471

//Symbolfolge
#define IDD_FREI_L	473
#define IDD_QUELLE	474
#define IDD_FOLGECOD_L	475
#define IDD_FREI_R	476
#define IDD_FOLGEDEC	477
#define IDD_FOLGECOD_R	478

//Konvertieren
#define IDD_NORMAL	480
#define IDD_NURKLEIN	481
#define IDD_NURGROSS	482
#define IDD_FLAGZI	483
#define IDD_FLAGLZ	484
#define IDD_FLAGIP	485
#define IDD_FLAGSZ	486
#define IDD_UMLAUT	487
#define IDD_KONVGROES	488

//bertragungsfehler
#define IDD_PBIT0	490
#define IDD_PBIT1	491
#define IDD_MANUELL	492

