#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <stdio.h>
#include <math.h>
#include "wdit.h"
#include "wdit_typ.h"
#include <commdlg.h>


extern LPSTR			  lpstrDec;
extern HWND            hwndSF, hwndHFK, hwndETP, hwndPAR;
extern HANDLE		     hBufferDec;
extern LPSTR			  lpstrCod;
extern HANDLE		     hBufferCod;
extern HMENU           hMenu;
extern HANDLE          hInst;
extern HCURSOR         hCurWait, hCurArrow;
extern HWND            hwndFrame;
extern STRUCT_FENSTER  Fenster;
extern STRUCT_TOCHTER  SF, HFK, ETP, PAR;
extern short			  Modell;
extern BOOL				  OK;
extern BOOL				  ungueltig;
extern BOOL				  codiert;
extern BOOL				  decodiert;
extern char            szFile[_MAX_PATH];
extern char				  szPuffer[_MAX_PATH];
extern char				  Code_Strn[8][8];
extern long				  lLength;
long						  lLengthCod;
float						  HFK_Cod[2];
void						  Huff_Decodieren(void);
extern void				  CODEeinlesen(HWND hDlg);
extern void 			  CODE_kontrolle(HWND hwnd);
extern void 			  HUF_Ausgabe(HDC hdc, short Zeichen, int xpos, int ypos,
											  RECT rect);

BOOL FAR PASCAL        HUFFDEC_DlgProc(HWND, UINT, UINT, LONG);

BOOL FAR PASCAL HUFFDEC_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
{
 BOOL			  selbsterstellt;
 short        i;
 extern BOOL  fehler(char*);

 switch (message)
  {
  case WM_INITDIALOG :

		  for (i=0; i<=7; i++)
		  {
		  EnableWindow(GetDlgItem(hDlg, IDD_DECODEa+i), FALSE);
		  SetDlgItemText (hDlg, IDD_DECODEa+i, (LPSTR) Code_Strn[i]);
		  }

		 return TRUE;

  case WM_COMMAND :
		 switch (wParam)
	{

	case IDD_HUFFDEC1:
		  for (i=0; i<=10; i++)
		  EnableWindow(GetDlgItem(hDlg, IDD_DECODEa+i), FALSE);
		  CODEeinlesen(hDlg);
		  selbsterstellt=FALSE;
		  for(i=0; i<=7;i++)
			SetDlgItemText (hDlg, IDD_DECODEa+i, (LPSTR) Code_Strn[i]);
		  return TRUE;

	case IDD_HUFFDEC2:
		  for (i=0; i<=10; i++)
		  EnableWindow(GetDlgItem(hDlg, IDD_DECODEa+i), TRUE);
		  selbsterstellt=TRUE;
		  return TRUE;

	case IDOK :
		  EndDialog (hDlg, 1);
		  if(selbsterstellt)
			{
			for(i=0; i<=7; i++)
			 GetDlgItemText (hDlg, IDD_DECODEa+i, (LPSTR) Code_Strn[i], 8);
			}
		  Fenster.aktualisiert=FALSE;
		  return TRUE;

	case IDCANCEL :
		  EndDialog (hDlg, 0);
		  return TRUE ;

	}
		 break ;

  }
 return FALSE ;
}



void HUFFDEC(HWND hwnd)
{
 FARPROC         lpDlgProc;

  if(!codiert)
	{
	MessageBox(hwndFrame, (LPSTR) "Bitte zuerst codieren!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}

 lpDlgProc = MakeProcInstance((FARPROC)HUFFDEC_DlgProc, hInst);
 OK=DialogBox(hInst, "HUFFDEC", hwnd, lpDlgProc);
 FreeProcInstance(lpDlgProc);

 if(OK)
  {
  CODE_kontrolle(hwnd);
  if(ungueltig)
	return;
  Huff_Decodieren();

  if(Fenster.SF)
	InvalidateRect(hwndSF, NULL, TRUE);
  }

 return;
}


void Huff_Decodieren(void)
 {
 char				Code[9];
 char				Bit[2];
 short			j, k, Zeichen;
 int				hFile;
 unsigned		i, l=0;
 int				laenge;

 SetCursor(hCurWait);
 strcpy(szPuffer, szFile);
 laenge=strlen(szPuffer);
 szPuffer[laenge-3]='h';
 szPuffer[laenge-2]='u';
 szPuffer[laenge-1]='f';

 if(-1 == (hFile = _lopen ((LPSTR)szPuffer, OF_READ|OF_SHARE_DENY_WRITE)))
  {
  MessageBox(hwndFrame, (LPSTR) "Datei kann nicht gelesen werden!",
	 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
  _lclose (hFile);
  return;
  }
  lLengthCod=filelength(hFile);

  Code[0]='\0';
  memset((lpstrCod), 0, 65500U);
  _lread (hFile, lpstrCod, 65000U);
  for(i=0; i<=lLengthCod-1; i++)
	{
	Bit[0]=*(lpstrCod+i);
	Bit[1]='\0';
	strcat(Code, Bit);
	for(j=0; j<=7; j++)
	 {
	 k=strcmp(Code, Code_Strn[j]);
	 if(k==0)
	  {
	  Zeichen=65+j;
	  if(Zeichen==72)
		Zeichen=32;
	  *(lpstrDec+l)=Zeichen;
	  l++;
	  Code[0]='\0';
	  break;
	  }
	 }
	decodiert=TRUE;

	if(strlen(Code)>=8)
	 {
	 MessageBox(hwndFrame, (LPSTR) "Datei nicht decodierbar!\n"
											 "Ursache: Falscher Huffman-Code",
		(LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	 decodiert=FALSE;
	 _lclose (hFile);
	 return;
	 }

	}
  _lclose (hFile);
 SetCursor(hCurArrow);

 return;
 }
