//--------------------------------------------------------------------------
//-------------------------------- PARAMETR.C ------------------------------
//--------------------------------------------------------------------------
//-- Parametereingabe Huffman-Codierung "Wertdiskrete Informationstheorie" -
//---------------------- Erstellt von: Georg Delle -------------------------



#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "wdit.h"
#include "wdit_typ.h"
#include <commdlg.h>
#include "dir.h"

extern LPSTR     					lpstrPar;
extern HANDLE				      hBufferPar;
extern LPSTR     					lpstrPar2;
extern HANDLE		          	hBufferPar2;
extern HCURSOR			         hCurWait, hCurArrow;
extern HMENU 			         hMenu;
extern HANDLE						hInst;
extern STRUCT_TOCHTER			ETP, HFK, SF;
extern STRUCT_FENSTER			Fenster;
extern char							szDirName[_MAX_PATH];
extern char                   szFile[_MAX_PATH];
extern short						Modell;
extern BOOL							OK;
extern unsigned					Datei_Groes;
extern long							lLength;
extern double						Statist_P[8];
extern double						Statist2_P[15];
extern float					   pMarkov2[2];
extern float					   pMarkov3;
extern float					  	KonstMarkov;
extern float			  			u[15];
extern BOOL				  			codiert;
extern BOOL							decodiert;
extern BOOL				  			OhneZI;
extern BOOL				  			OhneLZ;
extern BOOL				  			OhneIP;
extern BOOL				  			OhneSZ;
extern BOOL				  			Frei_L;
extern BOOL				  			Quelle;
extern BOOL            			Folge_L;
extern BOOL				  			Frei_R;
extern BOOL				  			Folgedec;
extern BOOL            			Folge_R;
char									Zeichen;
int									Zufall;
double								Grenze_U, Grenze_O;
extern BOOL FAR PASCAL        Statist_DlgProc(HWND, UINT, UINT, LONG);
extern BOOL FAR PASCAL        Markov2_DlgProc(HWND, UINT, UINT, LONG);
extern BOOL FAR PASCAL        Markov3_DlgProc(HWND, UINT, UINT, LONG);
extern BOOL			            fehler(char*);
BOOL FAR PASCAL			      Statist2_DlgProc(HWND, UINT, UINT, LONG);


BOOL FAR PASCAL Statist2_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
{

 char         szString[15];
 short        i;
 float		  Summe[4];


switch (message)
 {
 case WM_INITDIALOG:

	 for (i=0; i<=14; i++)
	  {
	 gcvt (Statist2_P[i], 7, szString);
	 SetDlgItemText (hDlg, IDD_PA2+i, (LPSTR) szString);
	  }
	 ltoa (Datei_Groes, szString, 10);
	 SetDlgItemText (hDlg, IDD_GROES_ABH, (LPSTR) szString);


	 return TRUE;


 case WM_COMMAND:
		switch (wParam)
		{

		case IDD_P_LZ:

			  for (i=0; i<=14; i++)
				{
				GetDlgItemText (hDlg, IDD_PA2+i, (LPSTR) szString, 7);
				Statist2_P[i]=atof(szString);
				if (Statist2_P[i]<0 || Statist2_P[i]>1 || fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzul\344ssiger Wert f\374r"
				  " Wahrscheinlichkeit!\n\n"
				  "M\366gliche Fehler:\n"
				  " - Wert > 1\n"
				  " - Wert < 0\n"
				  " - Komma wurde verwendet",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }
				}

			  memset(Summe, 0, 16);
				for(i=0; i<=1; i++)
				 Summe[0]+=Statist2_P[i];
				Statist2_P[2]=1.0-Summe[0];
				gcvt (Statist2_P[2], 7, szString);
				SetDlgItemText (hDlg, IDD_PC2, (LPSTR) szString);
				for(i=3; i<=5; i++)
				 Summe[1]+=Statist2_P[i];
				Statist2_P[6]=1.0-Summe[1];
				gcvt (Statist2_P[6], 7, szString);
				SetDlgItemText (hDlg, IDD_PAD, (LPSTR) szString);
				for(i=7; i<=9; i++)
				 Summe[2]+=Statist2_P[i];
				Statist2_P[10]=1.0-Summe[2];
				gcvt (Statist2_P[10], 7, szString);
				SetDlgItemText (hDlg, IDD_PBD, (LPSTR) szString);
				for(i=11; i<=13; i++)
				 Summe[3]+=Statist2_P[i];
				Statist2_P[14]=1.0-Summe[3];
				gcvt (Statist2_P[14], 7, szString);
				SetDlgItemText (hDlg, IDD_PCD, (LPSTR) szString);

			  return TRUE;


		case IDOK:
			  memset(Summe, 0, 16);
			  for (i=0; i<=14; i++)
				{
				GetDlgItemText (hDlg, IDD_PA2+i, (LPSTR) szString, 7);
				Statist2_P[i]=atof(szString);
				if (Statist2_P[i]<0 || Statist2_P[i]>1 || fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzul\344ssiger Wert f\374r"
				  " Wahrscheinlichkeit!\n\n"
				  "M\366gliche Fehler:\n"
				  " - Wert > 1\n"
				  " - Wert < 0\n"
				  " - Komma wurde verwendet",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }
				}

				for(i=0; i<=2; i++)
				 Summe[0]+=Statist2_P[i];
				for(i=3; i<=6; i++)
				 Summe[1]+=Statist2_P[i];
				for(i=7; i<=10; i++)
				 Summe[2]+=Statist2_P[i];
				for(i=11; i<=14; i++)
				 Summe[3]+=Statist2_P[i];

			  for(i=0; i<=3; i++)
				{
				if (Summe[i]<0.99999 || Summe[i]>1.0001)
				 {
				 if(MessageBox (hDlg,"Die Summe der Wahrscheinlichkeiten\n"
				  " ist ungleich eins!\n"
				  " Schalter 'Summe = 1' wurde nicht bentzt.",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }
				}
			  GetDlgItemText (hDlg, IDD_GROES_ABH, (LPSTR) szString, 6);
			  Datei_Groes=(unsigned)atol(szString);
		  if(fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzulssiger Wert fr Dateigre!",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }

			  if(Datei_Groes>60000U)
				{
				if(MessageBox (hDlg,"Die Groesse der Folge darf 60000 nicht berschreiten!",
					"Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				 return TRUE;
				else
				 {
				 EndDialog (hDlg, 0);
				 return TRUE;
				 }
				}
			  EndDialog (hDlg, 1);
			  return TRUE;

		case IDCANCEL:
			  EndDialog (hDlg, 0);
			  return TRUE;
		}
		break;

 }
 return FALSE;
}


void Statist1(HWND hwnd)
{
 FARPROC         lpDlgProc;
 unsigned		  i;

 lpDlgProc = MakeProcInstance((FARPROC)Statist_DlgProc, hInst);
 OK=DialogBox(hInst, "STATISTISCH", hwnd, lpDlgProc);
 FreeProcInstance(lpDlgProc);

 if(OK)
  {
  SetCursor(hCurWait);
  memset(lpstrPar, 0, 65500U);
  memset(lpstrPar2, 0, 65500U);
//Statistisch unabhngige Symbole erzeugen
	randomize();
	for(i=1; i<=(Datei_Groes); i++)
	 {
	 Grenze_U=0;
	 Grenze_O=Statist_P[0]*10000;
	 Zufall=random(10001);

	 if(Zufall >= Grenze_U && Zufall <= Grenze_O)
	  Zeichen=65;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[1]*10000;

	 if(Zufall > Grenze_U && Zufall <= Grenze_O)
	  Zeichen=66;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[2]*10000;

	 if(Zufall > Grenze_U && Zufall <= Grenze_O)
	  Zeichen=67;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[3]*10000;

	 if(Zufall > Grenze_U && Zufall <= Grenze_O)
	  Zeichen=68;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[4]*10000;

	 if(Zufall > Grenze_U && Zufall <= Grenze_O)
	  Zeichen=69;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[5]*10000;

	 if(Zufall > Grenze_U && Zufall <= Grenze_O)
	  Zeichen=70;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[6]*10000;

	 if(Zufall > Grenze_U && Zufall <= Grenze_O)
	  Zeichen=71;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[7]*10000;

	 if(Zufall > Grenze_U && Zufall <= Grenze_O)
	  Zeichen=32;

	 *(lpstrPar+i-1)=Zeichen;

	 }
  for(i=0; i<=7; i++)
	u[i]=Statist_P[i];
  Modell=1;
  codiert=FALSE;
  decodiert=FALSE;
  HFK.ermittelt1 = FALSE;
  ETP.ermittelt1 = FALSE;
  OhneZI=FALSE;
  OhneLZ=FALSE;
  OhneIP=FALSE;
  OhneSZ=FALSE;
  Frei_L=FALSE;
  Quelle=TRUE;
  Folge_L=FALSE;
  Frei_R=TRUE;
  Folgedec=FALSE;
  Folge_R=FALSE;
  EnableMenuItem(hMenu, IDM_HUFFCOD, MF_ENABLED);
  EnableMenuItem(hMenu, IDM_HUFFDEC, MF_ENABLED);
  EnableMenuItem(hMenu, IDM_UEBFEHLER, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_SFOPT, MF_ENABLED);
  EnableMenuItem(hMenu, IDM_HFKOPT, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_ETPOPT, MF_GRAYED);
  RemoveMenu(hMenu, IDM_HAEUFIG, MF_BYCOMMAND);
  if(!Fenster.null)//nur erforderlich falls mindestens 1 Fenster
	{               //offen
	EnableMenuItem(hMenu, IDM_RUN, MF_ENABLED);
	Fenster.aktualisiert = FALSE;
	}
  lLength=(long)Datei_Groes;
  }
 SetCursor(hCurArrow);
 strcpy(szFile, szDirName);
 strcat(szFile, "\\CODEDAT.HUF");
 return;
}


void Statist2(HWND hwnd)
{
 FARPROC         lpDlgProc;
 unsigned		  i;
 char				  Zeichen2;

 lpDlgProc = MakeProcInstance((FARPROC)Statist2_DlgProc, hInst);
 OK=DialogBox(hInst, "STATISTISCH2", hwnd, lpDlgProc);
 FreeProcInstance(lpDlgProc);

 if(OK)
  {
  SetCursor(hCurWait);
  memset(lpstrPar, 0, 65500U);
  memset(lpstrPar2, 0, 65500U);

//Statistisch unabhngige Symbole erzeugen
	randomize();
	for(i=0; i<=(Datei_Groes-1); i++)
	 {
	 Grenze_U=0;
	 Grenze_O=Statist2_P[0]*10000;
	 Zufall=random(10001);

	 if(Zufall >= Grenze_U && Zufall <= Grenze_O)
	  {
	  Zeichen=65;
	  }
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist2_P[1]*10000;

	 if(Zufall > Grenze_U && Zufall <= Grenze_O)
	  {
	  Zeichen=66;
	  }
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist2_P[2]*10000;

	 if(Zufall > Grenze_U && Zufall <= Grenze_O)
	  {
	  Zeichen=67;
	  }

	 *(lpstrPar+i)=Zeichen;
	 }

//2. Quelle erzeugen
	for(i=0; i<=(Datei_Groes-1); i++)
	 {
	 Zeichen=*(lpstrPar+i);

	 if(Zeichen==65)
	  {
	  Grenze_U=0;
	  Grenze_O=Statist2_P[3]*10000;
	  Zufall=random(10001);

	  if(Zufall >= Grenze_U && Zufall <= Grenze_O)
		{
		Zeichen2=97;
		}
	  Grenze_U=Grenze_O;
	  Grenze_O=Grenze_O+Statist2_P[4]*10000;

	  if(Zufall > Grenze_U && Zufall <= Grenze_O)
		{
		Zeichen2=98;
		}
	  Grenze_U=Grenze_O;
	  Grenze_O=Grenze_O+Statist2_P[5]*10000;

	  if(Zufall > Grenze_U && Zufall <= Grenze_O)
		{
		Zeichen2=99;
		}
	  Grenze_U=Grenze_O;
	  Grenze_O=Grenze_O+Statist2_P[6]*10000;

	  if(Zufall > Grenze_U && Zufall <= Grenze_O)
		{
		Zeichen2=100;
		}
	  }

	 if(Zeichen==66)
	  {
	  Grenze_U=0;
	  Grenze_O=Statist2_P[7]*10000;
	  Zufall=random(10001);

	  if(Zufall >= Grenze_U && Zufall <= Grenze_O)
		{
		Zeichen2=97;
		}
	  Grenze_U=Grenze_O;
	  Grenze_O=Grenze_O+Statist2_P[8]*10000;

	  if(Zufall > Grenze_U && Zufall <= Grenze_O)
		{
		Zeichen2=98;
		}
	  Grenze_U=Grenze_O;
	  Grenze_O=Grenze_O+Statist2_P[9]*10000;

	  if(Zufall > Grenze_U && Zufall <= Grenze_O)
		{
		Zeichen2=99;
		}
	  Grenze_U=Grenze_O;
	  Grenze_O=Grenze_O+Statist2_P[10]*10000;

	  if(Zufall > Grenze_U && Zufall <= Grenze_O)
		{
		Zeichen2=100;
		}
	  }

	 if(Zeichen==67)
	  {
	  Grenze_U=0;
	  Grenze_O=Statist2_P[11]*10000;
	  Zufall=random(10001);

	  if(Zufall >= Grenze_U && Zufall <= Grenze_O)
		{
		Zeichen2=97;
		}
	  Grenze_U=Grenze_O;
	  Grenze_O=Grenze_O+Statist2_P[12]*10000;

	  if(Zufall > Grenze_U && Zufall <= Grenze_O)
		{
		Zeichen2=98;
		}
	  Grenze_U=Grenze_O;
	  Grenze_O=Grenze_O+Statist2_P[13]*10000;

	  if(Zufall > Grenze_U && Zufall <= Grenze_O)
		{
		Zeichen2=99;
		}
	  Grenze_U=Grenze_O;
	  Grenze_O=Grenze_O+Statist2_P[14]*10000;

	  if(Zufall > Grenze_U && Zufall <= Grenze_O)
		{
		Zeichen2=100;
		}
	  }

	  *(lpstrPar2+i)=Zeichen2;
	 }

  Modell=2;
  HFK.ermittelt1 = FALSE;
  ETP.ermittelt1 = FALSE;
  OhneZI=FALSE;
  OhneLZ=FALSE;
  OhneIP=FALSE;
  OhneSZ=FALSE;
  EnableMenuItem(hMenu, IDM_HUFFCOD, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_HUFFDEC, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_UEBFEHLER, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_SFOPT, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_HFKOPT, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_ETPOPT, MF_GRAYED);
  RemoveMenu(hMenu, IDM_HAEUFIG, MF_BYCOMMAND);
  if(!Fenster.null)//nur erforderlich falls mindestens 1 Fenster
	{               //offen
	EnableMenuItem(hMenu, IDM_RUN, MF_ENABLED);
	Fenster.aktualisiert = FALSE;
	}
  lLength=(long)Datei_Groes;
  }
 SetCursor(hCurArrow);
 return;
}


void Markov2(HWND hwnd)
{
 FARPROC         lpDlgProc;
 unsigned		  i;

 lpDlgProc = MakeProcInstance((FARPROC)Markov2_DlgProc, hInst);
 OK=DialogBox(hInst, "MARKOV2", hwnd, lpDlgProc);
 FreeProcInstance(lpDlgProc);

 if(OK)
  {
  SetCursor(hCurWait);
  memset(lpstrPar, 0, 65500U);

	randomize();
	Zeichen=1;
	for(i=1; i<=(Datei_Groes+100); i++)
	 {
	 switch(Zeichen)
	  {
	  case 1:
				if(i>100)//Die ersten hundert Werte vernachlssigen
				 *(lpstrPar+i-101)=65;
				Zufall=random(10000)+1;
				if(Zufall<=(pMarkov2[0]*10000))
				 Zeichen=1;
				else
				 Zeichen=2;
				break;

	  case 2:
				if(i>100)//Die ersten hundert Werte vernachlssigen
				 *(lpstrPar+i-101)=66;
				Zufall=random(10000)+1;
				if(Zufall<=(pMarkov2[1]*10000))
				 Zeichen=2;
				else
				 Zeichen=1;
				break;

	  }
	 }

  Modell=3;
  HFK.ermittelt1 = FALSE;
  ETP.ermittelt1 = FALSE;
  EnableMenuItem(hMenu, IDM_HUFFCOD, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_HUFFDEC, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_UEBFEHLER, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_SFOPT, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_HFKOPT, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_ETPOPT, MF_ENABLED);
  RemoveMenu(hMenu, IDM_HAEUFIG, MF_BYCOMMAND);
  if(!Fenster.null)//nur erforderlich falls mindestens 1 Fenster
	{               //offen
	EnableMenuItem(hMenu, IDM_RUN, MF_ENABLED);
	Fenster.aktualisiert = FALSE;
	}
  lLength=(long)Datei_Groes;
  }
 SetCursor(hCurArrow);

 return;
}


void Markov3(HWND hwnd)
{
 FARPROC         lpDlgProc;
 unsigned		  i;

 lpDlgProc = MakeProcInstance((FARPROC)Markov3_DlgProc, hInst);
 OK=DialogBox(hInst, "MARKOV3", hwnd, lpDlgProc);
 FreeProcInstance(lpDlgProc);

 if(OK)
  {
  SetCursor(hCurWait);
  memset(lpstrPar, 0, 65500U);

	randomize();
	Zeichen=1;
	for(i=1; i<=(Datei_Groes+100); i++)
	 {
	 switch(Zeichen)
	  {
	  case 1:
				if(i>100)//Die ersten hundert Werte vernachlssigen
				 *(lpstrPar+i-101)=65;
				Zufall=random(10000)+1;
				if(Zufall<=(pMarkov3*KonstMarkov*10000))
				 Zeichen=1;
				else if(Zufall>(pMarkov3*KonstMarkov*10000) && (Zufall<=(2*pMarkov3*KonstMarkov*10000)))
				 Zeichen=2;
				else if(Zufall>(2*pMarkov3*KonstMarkov*10000))
				 Zeichen=3;
				break;

	  case 2:
				if(i>100)//Die ersten hundert Werte vernachlssigen
				 *(lpstrPar+i-101)=66;
				Zufall=random(10000)+1;
				if(Zufall<=(pMarkov3*10000))
				 Zeichen=2;
				else if(Zufall>(pMarkov3*10000) && (Zufall<=(2*pMarkov3*10000)))
				 Zeichen=3;
				else if(Zufall>(2*pMarkov3*10000))
				 Zeichen=1;
				break;

	  case 3:
				if(i>100)//Die ersten hundert Werte vernachlssigen
				 *(lpstrPar+i-101)=67;
				Zufall=random(10000)+1;
				if(Zufall<=(pMarkov3*10000))
				 Zeichen=3;
				else if(Zufall>(pMarkov3*10000) && (Zufall<=(2*pMarkov3*10000)))
				 Zeichen=1;
				else if(Zufall>(2*pMarkov3*10000))
				 Zeichen=2;
				break;

	  }
	 }

  Modell=4;
  HFK.ermittelt1 = FALSE;
  ETP.ermittelt1 = FALSE;
  EnableMenuItem(hMenu, IDM_HUFFCOD, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_HUFFDEC, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_UEBFEHLER, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_SFOPT, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_HFKOPT, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_ETPOPT, MF_ENABLED);
  RemoveMenu(hMenu, IDM_HAEUFIG, MF_BYCOMMAND);
  if(!Fenster.null)//nur erforderlich falls mindestens 1 Fenster
	{               //offen
	EnableMenuItem(hMenu, IDM_RUN, MF_ENABLED);
	Fenster.aktualisiert = FALSE;
	}
  lLength=(long)Datei_Groes;
  }
 SetCursor(hCurArrow);
 return;
}

