//-------------------------------------------------------------------------
//-------------------------------- SYNTHET.C --------------------------------
//-------------------------------------------------------------------------
//--------------- Dateioperationen "Wertdiskrete Informationstheorie"------
//-------------------- Erstellt von: Georg Delle --------------------------

#include <windows.h>
#include <math.h>
#include <commdlg.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include "wdit.h"
#include "wdit_typ.h"
#include "dir.h"

extern HWND            hwndFrame;
extern HANDLE			  hInst;
extern HCURSOR         hCurWait, hCurArrow;
extern char				  szDirName[_MAX_PATH];
extern char            szFile[_MAX_PATH];
extern char	           szPuffer[_MAX_PATH];
extern char				  drive[_MAX_DRIVE];
extern char				  dir[_MAX_DIR];
extern char				  file[_MAX_FNAME];
extern char				  ext[_MAX_EXT];
extern BOOL				  OK;
extern char				  Start[3];
extern long				  Groes_Text;
extern long huge		  Haeufigkeit3[35][35][35];
int						  Index[2];

extern BOOL	           fehler(char*);

BOOL FAR PASCAL        TEXT_DlgProc(HWND, UINT, UINT, LONG);

BOOL FAR PASCAL TEXT_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
 {
 int				i;
 char          szString[15];
 BOOL          good;

 switch (message)
  {
  case WM_INITDIALOG :

		 SetDlgItemText (hDlg, IDD_START, (LPSTR) Start);
		 ltoa(Groes_Text, szString, 10);
		 SetDlgItemText (hDlg, IDD_GROES_TEXT, (LPSTR) szString);

		 return TRUE ;

  case WM_COMMAND :
		 switch (wParam)
	{


	case IDOK :

		  GetDlgItemText (hDlg, IDD_START, (LPSTR) Start, 3);
		  if(Start[0]==32)
			Index[0]=26;
		  else
			Index[0]=Start[0]-97;
		  if(Start[1]==32)
			Index[1]=26;
		  else
			Index[1]=Start[1]-97;

		  if(Index[0]<0 ||Index[0]>26 || Index[1]<0 || Index[1]>26)
			{
			if(MessageBox (hDlg,"Unzul\344ssiges Zeichen eingeben!\n\n"
			"Es sind nur Kleinbuchstaben von 'a - z'\n"
			"und das Leerzeichen erlaubt",
			"Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
			return TRUE;
			else
			 {
			 EndDialog (hDlg, 0);
			 return TRUE;
			 }
			}

		  good=FALSE;

		  for(i=0; i<=26; i++)
			{
			if(Haeufigkeit3[Index[0]][Index[1]][i]>0)
			 good=TRUE;
			}

		  if(!good)
			{
			if(MessageBox (hDlg,"Unzul\344ssige Startkombination!\n\n"
			"Geben Sie eine andere ein.",
			"Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
			return TRUE;
			else
			 {
			 EndDialog (hDlg, 0);
			 return TRUE;
			 }
			}

		  GetDlgItemText (hDlg, IDD_GROES_TEXT, (LPSTR) szString, 9);
		  Groes_Text=atol(szString);

		  if(fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzulssiger Wert fr Dateigre!",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }

		  EndDialog (hDlg, 1);
		  return TRUE;


	case IDCANCEL :
		  EndDialog (hDlg, 0);
		  return TRUE ;

	}
		 break ;

  }
 return FALSE ;
}

void Text_Datei(HWND hwnd)
 {
 LPSTR           lpstrBuffer;
 HANDLE          hBuffer;
 FARPROC         lpDlgProc;
 OPENFILENAME 	  ofn;
 long				  hfk;
 unsigned		  pos;
 int          	  hFile, i, j, k;
 void 			  Synthetic(void);

 char         *szFilter[] = {"Hufigkeiten-Datei (*.hfk)","*.hfk", ""};
 szPuffer[0] = '\0';

 ofn.lStructSize        = sizeof(OPENFILENAME);
 ofn.hwndOwner          = hwndFrame;
 ofn.hInstance          = (HANDLE)NULL;
 ofn.lpstrFilter        = szFilter[0];
 ofn.lpstrCustomFilter  = (LPSTR)NULL;
 ofn.nMaxCustFilter     = 0L;
 ofn.nFilterIndex       = 1L;
 ofn.lpstrFile          = szPuffer;
 ofn.nMaxFile           = sizeof(szPuffer);
 ofn.lpstrFileTitle     = NULL;
 ofn.nMaxFileTitle      = 0;
 ofn.lpstrInitialDir    = szDirName;
 ofn.lpstrTitle         = (LPSTR)"Statistische Basis auswhlen (Hufigkeits-Datei)";
 ofn.Flags              = OFN_HIDEREADONLY;
 ofn.nFileOffset        = 0;
 ofn.nFileExtension     = 0;
 ofn.lpstrDefExt        = (LPSTR)NULL;
 ofn.lCustData          = 0L;
 ofn.lpfnHook           = (FARPROC)NULL;
 ofn.lpTemplateName     = (LPSTR)NULL;

//Hufigkeiten einlesen
 if(GetOpenFileName(&ofn))
  {
  SetCursor(hCurWait);
  if(-1 == (hFile = _lopen ((LPSTR)szPuffer, OF_READ|OF_SHARE_DENY_WRITE)))
	{
	MessageBox(hwndFrame, (LPSTR) "Datei kann nicht gelesen werden!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	_lclose (hFile);
	return;
	}

  _splitpath(szPuffer, drive, dir, file, ext);
  _makepath(szDirName, drive, dir, "", "");
  _fullpath(szDirName, szDirName, _MAX_PATH);
  hBuffer = GlobalAlloc (GHND, 65500L);
  lpstrBuffer=GlobalLock(hBuffer);

  _lread (hFile, lpstrBuffer, (WORD) 61236L);
  pos=0;
  for(i=0; i<=20; i++)
	{
	for(j=0; j<=26; j++)
	 {
	 for(k=0; k<=26; k++)
	  {
	  memmove(&hfk, (lpstrBuffer+pos), 4);
	  Haeufigkeit3[i][j][k]=hfk;
	  pos+=4;
	  }
	 }
	}

  _lread (hFile, lpstrBuffer, (WORD) 17496);
  pos=0;
  for(i=21; i<=26; i++)
	{
	for(j=0; j<=26; j++)
	 {
	 for(k=0; k<=26; k++)
	  {
	  memmove(&hfk, (lpstrBuffer+pos), 4);
	  Haeufigkeit3[i][j][k]=hfk;
	  pos+=4;
	  }
	 }
	}
  SetCursor(hCurArrow);
  _lclose (hFile) ;

//Startkombination
  lpDlgProc = MakeProcInstance((FARPROC)TEXT_DlgProc, hInst);
  OK=DialogBox(hInst, "TEXT", hwnd, lpDlgProc);
  FreeProcInstance(lpDlgProc);

//Syntetische Datei erzeugen
  if(OK)
   Synthetic();
  }

 GlobalUnlock(hBuffer);
 GlobalFree(hBuffer);

 return;
 }


void Synthetic(void)
 {
 LPSTR           lpstrBuffer;
 HANDLE          hBuffer;
 OPENFILENAME 	  ofn;
 long				  Summe, Zufall;
 long				  j, k, lLength;
 unsigned        l, lLaenge;
 int          	  hFile, i;
 float			  Random(long *k);
 long				  Grenze[27];

//	{
	char         *szFilter[] = {"Syntetische Textdatei (*.asc)","*.asc", ""};
	szPuffer[0] = '\0';

	ofn.lStructSize        = sizeof(OPENFILENAME);
	ofn.hwndOwner          = hwndFrame;
	ofn.hInstance          = (HANDLE)NULL;
	ofn.lpstrFilter        = szFilter[0];
	ofn.lpstrCustomFilter  = (LPSTR)NULL;
	ofn.nMaxCustFilter     = 0L;
	ofn.nFilterIndex       = 0L;
	ofn.lpstrFile          = szPuffer;
	ofn.nMaxFile           = sizeof(szPuffer);
	ofn.lpstrFileTitle     = NULL;
	ofn.nMaxFileTitle      = 0;
	ofn.lpstrInitialDir    = szDirName;
	ofn.lpstrTitle         = (LPSTR)"Wertdiskrete Informationstheorie";
	ofn.Flags              = OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
	ofn.nFileOffset        = 0;
	ofn.nFileExtension     = 0;
	ofn.lpstrDefExt        = (LPSTR)"ASC";
	ofn.lCustData          = 0L;
	ofn.lpfnHook           = (FARPROC)NULL;
	ofn.lpTemplateName     = (LPSTR)NULL;


	if(GetSaveFileName(&ofn))
	 {
	 SetCursor(hCurWait);
	 hBuffer = GlobalAlloc (GHND, 65500L);
	 lpstrBuffer=GlobalLock(hBuffer);
	 hFile= _lcreat (szPuffer, 0);
	 _splitpath(szPuffer, drive, dir, file, ext);
	 _makepath(szDirName, drive, dir, "", "");
	 _fullpath(szDirName, szDirName, _MAX_PATH);
	 Summe=0;
	 for(i=0; i<=26; i++)
	  Summe+=Haeufigkeit3[Index[0]][Index[1]][i];
	 randomize();
	 j=(long)rand();
	 k=(long)rand()*j;

//Startkombination schreiben
	 memset(lpstrBuffer, 0, 65500U);
	 if(Index[0]==26)
	  *(lpstrBuffer)=32;
	 else
	  *(lpstrBuffer)=Index[0]+97;
	 if(Index[1]==26)
	  *(lpstrBuffer+1)=32;
	 else
	  *(lpstrBuffer+1)=Index[1]+97;

//Datei erzeugen
	 lLength=Groes_Text;
	 while(lLength>0)
	  {
	  if(lLength<=65000L)
		lLaenge=(unsigned)lLength;
	  else
		lLaenge=(unsigned)65000L;
	  l=2;
	  while(l<=(lLaenge-1))
		{
		Summe=0;
		for(i=0; i<=26; i++)
		 {
		 Summe+=Haeufigkeit3[Index[0]][Index[1]][i];
		 Grenze[i]=Summe;
		 }
		if(Summe==0)
		 {
		 MessageBox (hwndFrame,"Falsche statistische Basis!\n\n"
			"Es drfen nur Hufigkeitsdateien von Texten verwendet werden,\n"
			"die mit folgenden Optionen konvertiert wurden:\n"
			"- ohne Ziffern\n"
			"- ohne Interpunktion\n"
			"- ohne Sonderzeichen\n"
			"- Umlaute umwandeln.",
			"Wertdiskrete Informationstheorie", MB_OK | MB_ICONSTOP);
		  _lclose(hFile);
		  GlobalUnlock(hBuffer);
		  GlobalFree(hBuffer);
		  SetCursor(hCurArrow);
		  return;
		 }
		Zufall=(Random(&k)*Summe);
		for(i=0; i<=26; i++)
		 {
		 if(Zufall < Grenze[i])
		  {
		  if(i==26)
			*(lpstrBuffer+l)=32;
		  else
			*(lpstrBuffer+l)=i+97;
		  Index[0]=Index[1];
		  Index[1]=i;
		  l++;
		  break;
		  }
		 }
		}
	  _lwrite (hFile, lpstrBuffer, lLaenge);
	  lLength-=lLaenge;
	  }
	 _lclose(hFile);
	 GlobalUnlock(hBuffer);
	 GlobalFree(hBuffer);
	 SetCursor(hCurArrow);
	 }
//	}

 return;
 }


float Random(long *k)
 {
 long				a=16807, m=2147483647L, q=127773L, r=2836, s;

 s=(long)floor((double)(*k/q));
 *k=a*(*k-q*s)-r*s;
 if(*k<=0)
  *k+=m;

 return((float)(*k/(float)(m)));
 }
