//-------------------------------------------------------------------------
//--------------------------------- WDIT.C ---------------------------------
//-------------------------------------------------------------------------
//----------------- Hauptprogramm "Wertdiskrete Informationstheorie" -----------------
//-------------------- Erstellt von: Georg Delle --------------------------

#include "string.h"
#include "dos.h";
#include "dir.h";
#include "wdit_var.h"


int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
			 LPSTR lpszCmdLine, int nCmdShow)
{
 HANDLE hAccel;
 HWND   hwndClient;
 MSG    msg ;
 char	  *rtemp;
 int	  data;
 struct ffblk ffblk;
 void   InitVar(void);
 BOOL   InitFirstInst(HANDLE) ;
 extern void			  Shannon(void);




 disk = getdisk();
 getcwd(directory, MAXPATH);//Ermitteln des aktuellen Verzeichnisses
 hInst = hInstance;
 rtemp=getenv("RTEMP");
 if(rtemp!=NULL)
  strcpy(szDirName, rtemp);
 else
  {
  strcpy(szDirName, directory);//Suchen nach Verzeichnis 'DATA'
  strcat(szDirName, "\\DATA");
  data = findfirst(szDirName, &ffblk, FA_DIREC);
  if(data==-1)//Verzeichnis 'DATA' erstellen
	mkdir(szDirName);
  }

 if(!hPrevInstance)
	{
	if(!InitFirstInst(hInstance))
	  {
	  MessageBox(NULL, (LPSTR) "Keine Registrierung der Fensterklassen!",
		 (LPSTR) "Wertdiskrete Informationstheorie: Fehler -> Programmabbruch",
		 MB_TASKMODAL|MB_ICONEXCLAMATION|MB_OK);
	  return FALSE;
	  }
	}
 else
	{
	GetInstanceData(hPrevInstance, szAppName, 5);
	GetInstanceData(hPrevInstance, szTitel, 35);
	}



 hwndFrame = CreateWindow (szAppName, szTitel,
			  WS_OVERLAPPEDWINDOW|WS_CLIPCHILDREN,
			  0, 0,
			  GetSystemMetrics(SM_CXSCREEN),
			  GetSystemMetrics(SM_CYSCREEN),
			  NULL, NULL, hInstance, NULL);
 if(!hwndFrame)
	MessageBox(NULL, (LPSTR) "Kein Hauptfenster erzeugt!",
	  (LPSTR) "Wertdiskrete Informationstheorie: Fehler -> Programmabbruch",
	  MB_TASKMODAL|MB_ICONEXCLAMATION|MB_OK);

 hwndClient = GetWindow(hwndFrame, GW_CHILD);
 hMenu = GetMenu(hwndFrame);
 hMenuWindow  = GetSubMenu (hMenu,  3);
 hCurWait = LoadCursor(NULL, IDC_WAIT);
 hCurArrow = LoadCursor(NULL, IDC_ARROW);
 hAccel = LoadAccelerators(hInstance, "Accel");
 InitVar();

 ShowWindow (hwndFrame, SW_SHOWMAXIMIZED) ;
 UpdateWindow (hwndFrame) ;
 Shannon();


 while (GetMessage (&msg, NULL, 0, 0))
			 {
	  if (!TranslateMDISysAccel (hwndClient, &msg) &&
			!TranslateAccelerator (hwndFrame, hAccel, &msg))
					{
					TranslateMessage (&msg) ;
					DispatchMessage (&msg) ;
					}
	  }

 return msg.wParam ;
}


BOOL InitFirstInst(HANDLE hInstance)
{
 WNDCLASS wndclass;

 LoadString(hInstance, IDSTR_NAME, szAppName, 5);
 LoadString(hInstance, IDSTR_TITEL, szTitel, 35);

 wndclass.style         = CS_HREDRAW | CS_VREDRAW;
 wndclass.lpfnWndProc   = KanalWndProc;
 wndclass.cbClsExtra    = 0 ;
 wndclass.cbWndExtra    = 0 ;
 wndclass.hInstance     = hInstance ;
 wndclass.hIcon         = LoadIcon (hInstance,
				    MAKEINTRESOURCE(WDIT_ICON));
 wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
 wndclass.hbrBackground = COLOR_APPWORKSPACE +1;
 wndclass.lpszMenuName  = "KanalMenu";
 wndclass.lpszClassName = szAppName ;

 if(!RegisterClass (&wndclass))
  return FALSE;

 wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
 wndclass.lpfnWndProc   = SFWndProc ;
 wndclass.cbClsExtra    = 0 ;
 wndclass.cbWndExtra    = 0 ;
 wndclass.hInstance     = hInstance ;
 wndclass.hIcon         = LoadIcon (hInstance,
					 MAKEINTRESOURCE(SF_ICON));
 wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
 wndclass.hbrBackground = GetStockObject(WHITE_BRUSH);
 wndclass.lpszMenuName  = NULL;
 wndclass.lpszClassName = (LPSTR)"SF";

 if(!RegisterClass (&wndclass))
  return FALSE;

 wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
 wndclass.lpfnWndProc   = HFKWndProc ;
 wndclass.cbClsExtra    = 0 ;
 wndclass.cbWndExtra    = 0 ;
 wndclass.hInstance     = hInstance ;
 wndclass.hIcon         = LoadIcon (hInstance,
				    MAKEINTRESOURCE(HFK_ICON));
 wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
 wndclass.hbrBackground = GetStockObject(WHITE_BRUSH);
 wndclass.lpszMenuName  = NULL;
 wndclass.lpszClassName = (LPSTR)"HFK";

 if(!RegisterClass (&wndclass))
  return FALSE;

 wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
 wndclass.lpfnWndProc   = ETPWndProc ;
 wndclass.cbClsExtra    = 0 ;
 wndclass.cbWndExtra    = 0 ;
 wndclass.hInstance     = hInstance ;
 wndclass.hIcon         = LoadIcon (hInstance,
				    MAKEINTRESOURCE(ETP_ICON));
 wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
 wndclass.hbrBackground = GetStockObject(WHITE_BRUSH);
 wndclass.lpszMenuName  = NULL;
 wndclass.lpszClassName = (LPSTR)"ETP";

 if(!RegisterClass (&wndclass))
  return FALSE;

 wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
 wndclass.lpfnWndProc   = SHWndProc ;
 wndclass.cbClsExtra    = 0 ;
 wndclass.cbWndExtra    = 0 ;
 wndclass.hInstance     = hInstance ;
 wndclass.hIcon         = LoadIcon (hInstance, MAKEINTRESOURCE(SH_ICON));
 wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
 wndclass.hbrBackground = GetStockObject(WHITE_BRUSH);
 wndclass.lpszMenuName  = NULL;
 wndclass.lpszClassName = (LPSTR)"SHANNON";

 if(!RegisterClass (&wndclass))
  return FALSE;

 wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
 wndclass.lpfnWndProc   = PARWndProc ;
 wndclass.cbClsExtra    = 0 ;
 wndclass.cbWndExtra    = 0 ;
 wndclass.hInstance     = hInstance ;
 wndclass.hIcon         = LoadIcon (hInstance,
					 MAKEINTRESOURCE(PAR_ICON));
 wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
 wndclass.hbrBackground = GetStockObject(WHITE_BRUSH);
 wndclass.lpszMenuName  = NULL;
 wndclass.lpszClassName = (LPSTR)"PAR";

 if(!RegisterClass (&wndclass))
  return FALSE;

 return TRUE;
}






void InitVar(void)
{
 Fenster.null = TRUE; //kein Fenster geoeffnet
 Fenster.aktualisiert = TRUE;//alle Fenster sind am Anfang aktualisiert
 Modell = 0;

//Speicher allocieren
 if(!(hBufferPar = GlobalAlloc (GHND, 65500L)))
  MessageBox(hwndFrame, (LPSTR) "Zuwenig Speicher vorhanden!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
 lpstrPar=GlobalLock(hBufferPar);
 if(!( hBufferPar2 = GlobalAlloc (GHND, 65500L)))
  MessageBox(hwndFrame, (LPSTR) "Zuwenig Speicher vorhanden!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
 lpstrPar2=GlobalLock(hBufferPar2);
 if(!( hBufferCod = GlobalAlloc (GHND, 65500L)))
  MessageBox(hwndFrame, (LPSTR) "Zuwenig Speicher vorhanden!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
 lpstrCod=GlobalLock(hBufferCod);
 if(!( hBufferDec = GlobalAlloc (GHND, 65500L)))
  MessageBox(hwndFrame, (LPSTR) "Zuwenig Speicher vorhanden!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
 lpstrDec=GlobalLock(hBufferDec);
 if(!( hBufferBkGround = GlobalAlloc (GHND, 131000L)))
  MessageBox(hwndFrame, (LPSTR) "Zuwenig Speicher vorhanden!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
 Bkground=(short *)GlobalLock(hBufferBkGround);
 if(!( hBufferHervorHeb = GlobalAlloc (GHND, 131000L)))
  MessageBox(hwndFrame, (LPSTR) "Zuwenig Speicher vorhanden!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
 HervorHeb=(short *)GlobalLock(hBufferHervorHeb);

 Statist_P[0] = .01;
 Statist_P[1] = .15;
 Statist_P[2] = .05;
 Statist_P[3] = .2;
 Statist_P[4] = .02;
 Statist_P[5] = .02;
 Statist_P[6] = .05;
 Statist_P[7] = .5;
 Datei_Groes = 1000;

 Statist2_P[0] = .3;
 Statist2_P[1] = .4;
 Statist2_P[2] = .3;
 Statist2_P[3] = .9;
 Statist2_P[4] = .1;
 Statist2_P[5] = 0.0;
 Statist2_P[6] = .0;
 Statist2_P[7] = .2;
 Statist2_P[8] = .6;
 Statist2_P[9] = .2;
 Statist2_P[10] = .0;
 Statist2_P[11] = .0;
 Statist2_P[12] = .1;
 Statist2_P[13] = .9;
 Statist2_P[14] = .0;

 pMarkov2[0]=.2;
 pMarkov2[1]=.3;
 pMarkov3=.3;
 KonstMarkov=0.1;
 K[0]=0.3;
 K[1]=0.7;
 K[2]=1;
 ueber_p=TRUE;
 strcpy(Zeich[0], "e");
 strcpy(Zeich[1], "s");
 strcpy(Zeich[2], "c");
 VorNach2=TRUE;
 VorNach3=TRUE;

 szAusblZeichen[0]='\0';
 AusblStelle=0;
 memset(AusblZeichen, 0, 68);

 pApBfest=TRUE;

 OhneZI=FALSE;
 OhneLZ=FALSE;
 OhneIP=FALSE;
 OhneSZ=FALSE;

 Frei_L=FALSE;
 Quelle=TRUE;
 Folge_L=FALSE;
 Frei_R=TRUE;
 Folgedec=FALSE;
 Folge_R=FALSE;

 codiert=TRUE;
 decodiert=FALSE;

 FlagNormal=TRUE;
 FlagKlein=FALSE;
 FlagGross=FALSE;
 FlagZI=FALSE;
 FlagLZ=FALSE;
 FlagIP=FALSE;
 FlagSZ=FALSE;
 FlagUmlaut=FALSE;
 pBit[0]=0.0;
 pBit[1]=0.0;
 manuell=FALSE;
 strcpy(Start,"en");
 Groes_Text=10000;



 return;
}


